;============================================================
;STRUCTURES
;============================================================

struct OptATXProcEntry
       STDProc		dd	?
       AMD3DNowProc	dd	?
       SSEProc		dd	?
ends

struct CheatHotKeyTableEntry
       KeyValue 	dd	?
       ProcAddress	dd	?	   ;null if none
ends

struct PTPOSINFO
       x		dd	?
       y		dd	?
       z		dd	?
       starttick	dd	?
ends


struct STDQUEUEINFO
       nodecount	dd	?
       newestnode	dd	?
       oldestnode	dd	?
       structsize	dd	?	;excludes STDQUEUENODE; must be DWORD multiple
       maxnodes 	dd	?
ends

struct STDQUEUENODE
       newernode	dd	?
       oldernode	dd	?     ;after this follows a custom entry struct
ends

;C++ type descriptor. Passed to MSVCRT.type_info.name method (returns unmangled name).
struct TypeDescriptor
       lpVTable 	dd	?
       spare		dd	?
       name		db	?	;(array of char containing mangled name)
ends

;DUMPS FROM DEMO 1.1 EXE

;constructs type_info class
;* Reference To: MSVCRT.?name@type_info@@QBEPBDXZ, Ord:0029h
;Names in TRESPASS, item 646
; Address=0064C354
; Section=.rdata
; Type=Import
; Name=MSVCRT.type_info::name

;demangles name
;* Reference To: MSVCRT.??1type_info@@UAE@XZ, Ord:000Eh
;Names in TRESPASS, item 647
; Address=0064C274
; Section=.rdata
; Type=Import
; Name=MSVCRT.type_info::~type_info


struct HUDImgInfo
       Width		dd	?
       Height		dd	?
       Size		dd	?
       lpBmpData	dd	?
ends


struct HUDBGInfo
       AlignmentX	dd	?
       AlignmentY	dd	?
       DisplacementX	dd	?
       DisplacementY	dd	?
       DigitsOffsetX	dd	?
       DigitsOffsetY	dd	?
       Digits2OffsetX	dd	?
       Digits2OffsetY	dd	?
       UseDigitPadding	dd	?
       UseResizing	dd	?
       ResizeResX	dd	?
       ResizeResY	dd	?
       UseDigits2	dd	?
ends

struct HUDDigitsInfo
       D0		HUDImgInfo
       D1		HUDImgInfo
       D2		HUDImgInfo
       D3		HUDImgInfo
       D4		HUDImgInfo
       D5		HUDImgInfo
       D6		HUDImgInfo
       D7		HUDImgInfo
       D8		HUDImgInfo
       D9		HUDImgInfo
ends

struct HUDDigits
       D0		dd	0
       D1		dd	0
       D2		dd	0
       D3		dd	0
       D4		dd	0
       D5		dd	0
       D6		dd	0
       D7		dd	0
       D8		dd	0
       D9		dd	0
ends

;mov eax,[LocationAddr]
;mov edx,[eax]
;mov eax,[edx+34h]
;[eax+0] = sub-pointer for start of tree structure
;[eax+4] = number of instances in tree structure
;mov edx,[eax]
;[edx+4] = root node
;[edx+8] = left-most node (lowest InstanceID value)
;[edx+12] = right-most node (highest InstanceID value)
;in node, if NextLeftNode=NextRightNode, we have
;a leaf, if one points to a node with both equal,
;we've reached a left-right end

struct TresTreeNode
    Unknown			dd	?
    PreviousNode		dd	?
    NextLeftNode		dd	?
    NextRightNode		dd	?
    InstanceID			dd	?
    InstanceAddress		dd	?
ends

struct AT114Instance
    lpVTable			dd	?
    Reserved			dd	?
    TotalProbabilityCount	dd	?
    NumberOfGroups		dd	?
    NumberOfInstances		dd	?
    lpInstanceList		dd	?
    lpGroupsProbabilitiesList	dd	?
    lpGroupLocationFlags	dd	?  ;points to buffer of bytes, one for each location entry of each group
    lpGroupData 		dd	?  ;points to buffer of pointers to location entries
ends

;size will ONLY grow with new ATX versions, new members appended only
struct animproj_info
    ProjectileInstance			dd	8 dup ?
    NextProjectileIndex 		dd	?
    MinDistanceEXP2			dd	?
    MinDistanceHorizEXP2		dd	?
    DistanceFromHead			dd	?
    ProjectileSpeed			dd	?
    LaunchProbability			dd	?
    MinInterval 			dd	?
    LastTick				dd	?
    AnimalViewAngle			dd	?
    AnimalViewAngleCosine		dd	?
    ProjectileExtinguishTime		dd	?
    ProjectileZSpeedAdjust		dd	?
    UseHorizontalAutoAim		db	?
    UseVerticalAutoAim			db	?
					db	?
					db	?
    ProbabilityInterval 		dd	?
    ProbabilityInterval_LastTick	dd	?
ends


struct jump_info			;for compatibility issues, this is kept separate from canimal_info
    Push		    dd	    ?
    JumpAngle		    dd	    ?
    JumpTendancy	    dd	    ?
    RepeatPeriod	    dd	    ?
    LastTickCount	    dd	    ?
    TendancyCheckPeriod     dd	    ?
    TendancyCheck_LastTick  dd	    ?
    Flags		    dd	    ?
    MaxBodyAngleWithTarget  dd	    ?	 ; (cosine of)
    MaxHeadAngleWithTarget  dd	    ?	 ; (cosine of)
    MinTotalVelocity	    dd	    ?	 ; (^2)
    MinVelocityDirectional  dd	    ?	 ; (as-is)
    MaxVelocityDirAngle     dd	    ?	 ; (cosine of)
    MinTargetDistance	    dd	    ?	 ; (^2)
    MaxTargetDistance	    dd	    ?	 ; (^2)
ends

; jump_info.Flags possible members
JUMP_INFO_NEWCOND_MAXBODYANGLE	       equ     1h
JUMP_INFO_NEWCOND_MAXHEADANGLE	       equ     2h
JUMP_INFO_NEWCOND_MINTOTALSPEED        equ     4h
JUMP_INFO_NEWCOND_MINDIRSPEED	       equ     8h
JUMP_INFO_NEWCOND_MAXDIRANGLE	       equ    10h
JUMP_INFO_NEWCOND_MINDISTANCE	       equ    20h
JUMP_INFO_NEWCOND_MAXDISTANCE	       equ    40h
JUMP_INFO_NEWCOND_ALL		       equ    (JUMP_INFO_NEWCOND_MAXBODYANGLE+JUMP_INFO_NEWCOND_MAXHEADANGLE+\
					       JUMP_INFO_NEWCOND_MINTOTALSPEED+JUMP_INFO_NEWCOND_MINDIRSPEED+\
					       JUMP_INFO_NEWCOND_MAXDIRANGLE+JUMP_INFO_NEWCOND_MINDISTANCE+\
					       JUMP_INFO_NEWCOND_MAXDISTANCE)

struct initial_info		  ;(standard location-orientation Tres format)
    Xpos	       dd      ?
    Ypos	       dd      ?
    Zpos	       dd      ?
    Wquat	       dd      ?
    Xquat	       dd      ?
    Yquat	       dd      ?
    Zquat	       dd      ?
ends

struct canimal_info
    Instance	       dd      ?	;for backward compatibility, should always be the first member of this struc
    Count	       dd      ?	;from 0 to infinite
    InitialData        initial_info
ends

struct CParticlesDefault
     Blood	       dd ?
     Bleed	       dd ?
     Water	       dd ?
     Terrain	       dd ?
     TerrainSand       dd ?
     MetalHard1        dd ?
ends


;must begin all atxdrv structures
struct atxdrv_base
    VTable	       dd      ?
    Ref 	       dd      ?
    Type	       dd      ?
    Instance	       dd      ?
    TempInstance       dd      ?
ends

struct vector
    X		    dd	    ?
    Y		    dd	    ?
    Z		    dd	    ?
ends

struct quaternion
    W		      dd      ?
    X		      dd      ?
    Y		      dd      ?
    Z		      dd      ?
ends

struct atxdrv_inst_data 	;should be DWORD aligned, no negative values
    VTable	       dd      ?
    Ref 	       dd      ?
    Type	       dd      ?
    Instance	       dd      ?
    TempInstance       dd      ?
    GravityPush        dd      ?
    KeyHandlerTick     dd      ?
    MvtHandlerTick     dd      ?
    RotPosOffset       dd      ?       ;rotation position offset (1D, offsets effect of rotation)
    FrontFastAccel     dd      ?       ;floats/s^2 (acceleration)
    FrontSlowAccel     dd      ?
    BackSlowAccel      dd      ?
    BackBrakeDecel     dd      ?       ;used when velocity > 0
    NaturalDecel       dd      ?       ;used when no mvt keys pressed
    RotationAccelL     dd      ?       ;should be positive - rotation acceleration (left and right) (radian angles/S^2)
    RotationAccelR     dd      ?       ;should be negative
    RotationDecel      dd      ?       ;used when no rotation keys pressed (should be high)
    MaxFastVelocity    dd      ?
    MaxSlowVelocity    dd      ?       ;approximate
    MaxBackVelocity    dd      ?       ;CONVERT FROM POSITIVE TO NEGATIVE
    MaxTurnVelocityL   dd      ?
    MaxTurnVelocityR   dd      ?       ;CONVERT FROM POSITIVE TO NEGATIVE
    MinVelocityForTurn dd      ?
ends

struct atxdrv_type1	    ;should be DWORD aligned, no negative values
    VTable	       dd      ?    ;standard
    Ref 	       dd      ?
    Type	       dd      ?
    Instance	       dd      ?
    TempInstance       dd      ?
    Tick	       dd      ?    ;keyrate limiter
    FWDFast	       dd      ?    ;acceleration values
    FWDSlow	       dd      ?
    BackSlow	       dd      ?    ; -> BackSlow = negative value
    BackBrake	       dd      ?    ; -> BackBrake = negative value
    LeftRight	       dd      ?
    FastLimit	       dd      ?    ;velocity values (do not apply acceleration
    SlowLimit	       dd      ?    ;if velocity is higher than these values in object's current
    BackLimit	       dd      ?    ;direction)   -> BackLimit = negative value
    LeftRightLimit     dd      ?
    MvtZAngleMul       dd      ?
    UseQuatMulInvert   dd      ?
ends

struct atxdrv_initial_velocity
    XVelocity	       dd      ?
    YVelocity	       dd      ?
    ZVelocity	       dd      ?
    WQuat	       dd      ?
    XQuat	       dd      ?
    YQuat	       dd      ?
    ZQuat	       dd      ?
ends

struct CAPTUREPARMS		;size = 96
    dwRequestMicroSecPerFrame	       dd      ?
    fMakeUserHitOKToCapture	       dd      ?
    wPercentDropForError	       dd      ?
    fYield			       dd      ?
    dwIndexSize 		       dd      ?
    wChunkGranularity		       dd      ?
    fUsingDOSMemory		       dd      ?
    wNumVideoRequested		       dd      ?
    fCaptureAudio		       dd      ?
    wNumAudioRequested		       dd      ?
    vKeyAbort			       dd      ?
    fAbortLeftMouse		       dd      ?
    fAbortRightMouse		       dd      ?
    fLimitEnabled		       dd      ?
    wTimeLimit			       dd      ?
    fMCIControl 		       dd      ?
    fStepMCIDevice		       dd      ?
    dwMCIStartTime		       dd      ?
    dwMCIStopTime		       dd      ?
    fStepCaptureAt2x		       dd      ?
    wStepCaptureAverageFrames	       dd      ?
    dwAudioBufferSize		       dd      ?
    fDisableWriteCache		       dd      ?
    AVStreamMaster		       dd      ?
ends

struct AVISTREAMINFO
    fccType			       dd      ?
    fccHandler			       dd      ?
    dwFlags			       dd      ?
    dwCaps			       dd      ?
    wPriority			       dw      ?
    wLanguage			       dw      ?
    dwScale			       dd      ?
    dwRate			       dd      ?
    dwStart			       dd      ?
    dwLength			       dd      ?
    dwInitialFrames		       dd      ?
    dwSuggestedBufferSize	       dd      ?
    dwQuality			       dd      ?
    dwSampleSize		       dd      ?
    rcFrame			       RECT
    dwEditCount 		       dd      ?
    dwFormatChangeCount 	       dd      ?
    szName			       db      64 dup ?
ends

struct AVICOMPRESSOPTIONS
    fccType			       dd      ?
    fccHandler			       dd      ?
    dwKeyFrameEvery		       dd      ?
    dwQuality			       dd      ?
    dwBytesPerSecond		       dd      ?
    dwFlags			       dd      ?
    lpFormat			       dd      ?
    cbFormat			       dd      ?
    lpParms			       dd      ?
    cbParms			       dd      ?
    dwInterleaveEvery		       dd      ?
ends

struct DIBDUMPHEADER
    AtxDIBId			       db      'ATXR'	   ;if included in final file, save was successful
    SaveFlags			       dd      ?
    HeaderSize			       dd      sizeof.DIBDUMPHEADER
    BitmapData			       BITMAPINFOHEADER 	sizeof.BITMAPINFOHEADER
    Framerate			       dd      ?
    FrameRepeatTableFileOffset	       dd      ?
    FrameRepeatTableFileOffsetHigh     dd      ?
    DiffFrameCount		       dd      ?	  ;excludes frame repetitions (new frames only)
    TrueFrameCount		       dd      ?	  ;includes repetitions
    MaxFrameCount		       dd      ?
    FrameRepCount		       dd      ?
    rv_rt_error_count		       dd      ?
ends


