;=====================================================
;DISPLAYS LINST CHEAT DATA - INCOMPLETE
;=====================================================
DisplayLINSTData:
push ebp

	mov eax,[BaseDDSurfaceADDR]
	mov ecx,[eax]
	call [EXEPROC_GETDDSURFDC]	;GetDC for DDraw surface via EXE
	mov edi,eax
	mov ebx,stack_ext_buffer

;print instance count
	invoke wsprintf,ebx,LINST_instcount_STR,[LINST_InstanceCount]
	add esp,12
	invoke TextOut,edi,0,LINST_DISPLAY_MSG,ebx,eax

;check for 0 instances case
	cmp [LINST_InstanceCount],0
	    jz EXITKEYHANDLER_PASSIVE

	mov ebp,[LINST_CurrentNode]
	test ebp,ebp
	     jz DisplayLINSTData_NOINSTANCES

;print instance's string ID from chain object
	invoke wsprintf,ebx,LINST_instID_STR,DWORD [ebp+TresTreeNode.InstanceID]
	add esp,12
	invoke TextOut,edi,0,LINST_DISPLAY_MSG+10h,ebx,eax

;print instance's base address
	invoke wsprintf,ebx,LINST_instaddr_STR,DWORD [ebp+TresTreeNode.InstanceAddress]
	add esp,12
	invoke TextOut,edi,0,LINST_DISPLAY_MSG+20h,ebx,eax

;print instance's VTable address
	mov eax,[ebp+TresTreeNode.InstanceAddress]
	invoke wsprintf,ebx,LINST_instvtable_STR,DWORD [eax]
	add esp,12
	invoke TextOut,edi,0,LINST_DISPLAY_MSG+30h,ebx,eax

;print instance's VTable type (formatted)
	mov eax,[ebp+TresTreeNode.InstanceAddress]
	mov edx,[eax]		;VTable address
	mov ecx,[edx-4] 	;debug info member (precedes VTable)
	mov eax,[ecx+0Ch]	;sub- debug info member
	add eax,(8+4)		;".?AV" string start at +8, but skips first characters for clarity

	lea edx,[ebx+300]
    ;move string, and cut string off at "@@" characters or at null-terminator
	DisplayLINSTData_VTableTypeLOOP:
	mov cl,[eax]
	cmp WORD [eax],'@@'
	mov [edx],cl
	    jz END_DisplayLINSTData_VTableTypeLOOP
	cmp BYTE [eax],0
	    jz END_DisplayLINSTData_VTableTypeLOOP
	inc eax
	inc edx
	jmp DisplayLINSTData_VTableTypeLOOP
    END_DisplayLINSTData_VTableTypeLOOP:
	mov BYTE [edx],0

	lea edx,[ebx+300]
	invoke wsprintf,ebx,LINST_insttype_STR,edx
	add esp,12
	invoke TextOut,edi,0,LINST_DISPLAY_MSG+40h,ebx,eax

	push LINST_nt_right_STR 	 ;defaults
	push LINST_nt_left_STR
	push LINST_nt_std_STR

	cmp ebp,[LINST_RootNode]
	    jnz DisplayLINSTData_NotRootNode
	    mov DWORD [esp],LINST_nt_root_STR
	DisplayLINSTData_NotRootNode:

	mov eax,[ebp+TresTreeNode.NextLeftNode]
	cmp [eax+TresTreeNode.NextLeftNode],0
	    jnz DisplayLINSTData_HasLeftNode
	    mov DWORD [esp+4],LINST_nt_noleft_STR
	DisplayLINSTData_HasLeftNode:

	mov eax,[ebp+TresTreeNode.NextRightNode]
	cmp [eax+TresTreeNode.NextLeftNode],0
	    jnz DisplayLINSTData_HasRightNode
	    mov DWORD [esp+8],LINST_nt_noright_STR
	DisplayLINSTData_HasRightNode:

	invoke wsprintf,ebx,LINST_nodetype_STR
	add esp,20
	invoke TextOut,edi,0,LINST_DISPLAY_MSG+50h,ebx,eax

;exit procedure
	DisplayLINSTData_NOINSTANCES:
	mov eax,[BaseDDSurfaceADDR]
	push edi		 ;DDraw ReleaseDC
	mov ecx,[eax]
	call [EXEPROC_RELEASEDDSURFDC]

pop ebp
ret

;===============================================================
;Key handling code         ;LINST_currchainobj
;===============================================================
LINST_cycleleftkeypressed:
cmp [LINST_enabled],FALSE
    jz EXITKEYHANDLER_PASSIVE
cmp [LINST_InstanceCount],0
    jz EXITKEYHANDLER_PASSIVE

    mov eax,[LINST_CurrentNode]
    mov ecx,[eax+TresTreeNode.NextLeftNode]

    cmp [ecx+TresTreeNode.NextLeftNode],0	  ;if current node as 'no' next node, there will be a next node but its left and right members will be null
	jz EXITKEYHANDLER_PASSIVE

    mov [LINST_CurrentNode],ecx

jmp EXITKEYHANDLER_PASSIVE
;===============================================================
LINST_cyclerightkeypressed:
cmp [LINST_enabled],FALSE
    jz EXITKEYHANDLER_PASSIVE
cmp [LINST_InstanceCount],0
    jz EXITKEYHANDLER_PASSIVE

    mov eax,[LINST_CurrentNode]
    mov ecx,[eax+TresTreeNode.NextRightNode]

    cmp [ecx+TresTreeNode.NextLeftNode],0	  ;if current node as 'no' next node, there will be a next node but its left and right members will be null
	jz EXITKEYHANDLER_PASSIVE

    mov [LINST_CurrentNode],ecx

jmp EXITKEYHANDLER_PASSIVE

;sadfasdfsadf dd 005EE140h
;asdfasdfdssdfsdfsdfa  dd 0675E44h
;===============================================================
LINST_cyclepreviouskeypressed:
cmp [LINST_enabled],FALSE
    jz EXITKEYHANDLER_PASSIVE
cmp [LINST_InstanceCount],0
    jz EXITKEYHANDLER_PASSIVE

    mov eax,[LINST_CurrentNode]
    cmp eax,[LINST_RootNode]
	jz EXITKEYHANDLER_PASSIVE

    mov ecx,[eax+TresTreeNode.PreviousNode]
    mov [LINST_CurrentNode],ecx

jmp EXITKEYHANDLER_PASSIVE

;===============================================================