
;=======================================================
; class CSynthesizer
;=======================================================

#label CSynthesizer::CSynthesizer()_0 = 0x00611FB0, 0, 0, 0
#label CSynthesizer::SynthesizeActivities()_0 = 0x00612490, 0, 0, 0

CSynthesizer CSynthesizer::CSynthesizer(
);

VOID CSynthesizer::SynthesizeActivities(
);

#label CallCActivityMain = 0x006126BE

This is where all the main CActivity functions are called.

;=======================================================
; class CAIInfo
;=======================================================

#label CAIInfo::CAIInfo()_2 = 0x0060B200, 0, 0, 0
#label CAIInfo::CAIInfo()_4 = 0x0060B250, 0, 0, 0
#label CAIInfo::CAIInfo()_1 = 0x0060C5D0, 0, 0, 0

CAIInfo CAIInfo::CAIInfo(
 UNKNOWN Param1,
 UNKNOWN Param2
);

CAIInfo CAIInfo::CAIInfo(
 UNKNOWN Param1,
 UNKNOWN Param2,
 UNKNOWN Param3,
 UNKNOWN Param4
);

CAIInfo CAIInfo::CAIInfo(
 UNKNOWN Param1
);

;=======================================================
; class CBrain
;=======================================================

#label CBrain::CBrain()_6 = 0x0060C910, 0, 0, 0
#label CBrain::Update()_0 = 0x0060E8A0, 0, 0, 0
#label CBrain::~CBrain()_0 = 0x0060D7C0, 0, 0, 0

CBrain CBrain::CBrain(
 UNKNOWN Param1,
 UNKNOWN Param2,
 UNKNOWN Param3,
 UNKNOWN Param4,
 UNKNOWN Param5,
 UNKNOWN Param6
);


VOID CBrain::Update(
);

Main AI calculations and synchronizations for the
CAnimal instance associated with this CBrain instance.
Calls appropriate CActivity-inheritor functions.
Also updates some CAISystem class members.

VOID CBrain::~CBrain(
);

;=======================================================
; class CMentalState
;=======================================================

#label CMentalState::CMentalState()_0 = 0x006150C0, 0, 0, 0

CMentalState CMentalState::CMentalState(
);

;=======================================================
; class CActivity
;=======================================================

#label CActivity::CActivity()_1 = 0x00615910, 0, 0, 0
#label CActivity::OutputMessage()_1 = 0x00616A90, 0, 0, 0
#label CActivity::PlayDinoSound()_1 = 0x006167C0
#label CActivity::SetEnabledState()_virtual_1 = 0x0060E490

CActivity CActivity::CActivity(
 UNKNOWN Param1
);


VOID CActivity::OutputMessage(
 LPCTSTR lpMessageString
);

Currently does nothing (would have been used during
development).

BOOL CActivity::PlayDinoSound(
 INT Vocal
); 

Called at 11 locations.

VOID CActivity::SetEnabledState(
 BOOL ActivityState
);

Sets or unsets "activity enabled" flag in "this" activity.
Method [ICActivity+04h]


;=======================================================
; class CActivityCompound
;=======================================================

#label CActivityCompound::CActivityCompound()_1 = 0x0060E4B0, 0, 0, 0
#label CActivityCompound::~CActivityCompound()_virtual_1 = 0x0060E4F0, 0, 0, 0

CActivityCompound CActivityCompound::CActivityCompound(
 UNKNOWN Param1
);

VOID CActivityCompound::~CActivityCompound(
 BOOL FreeInstanceMemory
);

;=======================================================
; class CNodeSource
;=======================================================

#label CNodeSource::CNodeSource()_0 = 0x0061C7F0, 0, 0, 0

CNodeSource CNodeSource::CNodeSource(
);

;=======================================================
; class CInfluence
;=======================================================

sizeof.CInfluence >= 344h	;(probably greater)

#label CInfluence::CInfluence()_1 = 0x0060FD40, 0, 0, 0
#label CInfluence::CInfluence()_1 = 0x00614F00, 0, 0, 0
#label CInfluence::CInfluence()_2 = 0x0061CDD0, 0, 0, 0
#label CInfluence::CInfluence()_1 = 0x0061ECA0, 0, 0, 0
#label CInfluence::~CInfluence()_1 = 0x00614DE0, 0, 0, 0
#label CInfluence::GetFlagUnknown()_0 = 0x0061EA60

CInfluence CInfluence::CInfluence(
 UNKNOWN Param1
);

CInfluence CInfluence::CInfluence(
 UNKNOWN Param1
);

Copies instances.

CInfluence CInfluence::CInfluence(
 UNKNOWN Param1,
 UNKNOWN Param2
);

UNKNOWN CInfluence::CInfluence(
 UNKNOWN Param1
);   // does not return same object

VOID CInfluence::~CInfluence(
 BOOL FreeInstanceMemory
);

BOOL CInfluence::GetFlagUnknown(
);

Returns bit 4 of DWORD [CInfluence+340h] in al as boolean.
According to ActBite code, this flag, if true, may mean
"is player facing away?"


;=======================================================
; class CAIGraph
;=======================================================

#label CAIGraph::CAIGraph()_2 = 0x00610EC0, 0, 0, 0

CAIGraph CAIGraph::CAIGraph(
 UNKNOWN Param1,
 UNKNOWN Param2
);

;=======================================================
; class CNHInvalid
;=======================================================
sizeof.CNHInvalid >= 0Ch

#label CNHInvalid::CNHInvalid()_0 = 0x00611120, 0, 0, 0

CNHInvalid CNHInvalid::CNHInvalid(
);

5 inst.

;=======================================================
; class CWorldView
;=======================================================
#label CWorldView::CWorldView()_1 = 0x00613060, 0, 0, 0
#label CWorldView::~CWorldView()_0 = 0x00613150, 0, 0, 0

CWorldView CWorldView::CWorldView(
 UNKNOWN Param1
);

VOID CWorldView::~CWorldView(
);

;=======================================================
; class CActivityDistance
;=======================================================
sizeof.CActivityDistance >= 064h

#label CActivityDistance::CActivityDistance()_1 = 0x00616B60, 0, 0, 0
#label CActivityDistance::Unknown1()_3 = 0x00616B90

CActivityDistance CActivityDistance::CActivityDistance(
 UNKNOWN Param1
);

LPFLOAT CActivityDistance::Unknown1(
 LPFLOAT lpSomeFloat,		  // returned by function
 LPUNKNOWN lpUnknownFloats,	  // pointer to input values
 LPCINFLUENCE lpInfluence
); // returns a pointer to a 32-bit float (lpSomeFloat)

This is a case of polymorphic direct-call method (non-virtual). It is called
at four locations, and the "this" instance can be of any
CActivityDistance-inheriting class (polymorphic, or course) such
as CActivityMoveCommandToward, CActivityMoveBy, etc.

;=======================================================
; class CActivityVocal
;=======================================================

#label CActivityVocal::CActivityVocal()_1 = 0x0061A560, 0, 0, 0

CActivityVocal CActivityVocal::CActivityVocal(
 UNKNOWN Param1
);

;=======================================================
; class CActivitySniffAir
;=======================================================

#label CActivitySniffAir::CActivitySniffAir()_1 = 0x006175D0, 0, 0, 0

CActivitySniffAir CActivitySniffAir::CActivitySniffAir(
 UNKNOWN Param1
);

;=======================================================
; class CActivitySniffTarget
;=======================================================

#label CActivitySniffTarget::CActivitySniffTarget()_0 = 0x00616E40, 0, 0, 0

CActivitySniffTarget CActivitySniffTarget::CActivitySniffTarget(
);

;=======================================================
; class CActivityGlare
;=======================================================

#label CActivityGlare::CActivityGlare()_0 = 0x006170C0, 0, 0, 0

CActivityGlare CActivityGlare::CActivityGlare(
);

;=======================================================
; class CActivityCockHead
;=======================================================

#label CActivityCockHead::CActivityCockHead()_0 = 0x00617360, 0, 0, 0

CActivityCockHead CActivityCockHead::CActivityCockHead(
);

;=======================================================
; class CActivityLookAround
;=======================================================

#label CActivityLookAround::CActivityLookAround()_0 = 0x00617780, 0, 0, 0

CActivityLookAround CActivityLookAround::CActivityLookAround(
);

;=======================================================
; class CActivityRearBack
;=======================================================

#label CActivityRearBack::CActivityRearBack()_0 = 0x00617CE0, 0, 0, 0

CActivityRearBack CActivityRearBack::CActivityRearBack(
);

;=======================================================
; class CActivityCower
;=======================================================

#label CActivityCower::CActivityCower()_0 = 0x00617FA0, 0, 0, 0

CActivityCower CActivityCower::CActivityCower(
);

;=======================================================
; class CActivityNothing
;=======================================================

#label CActivityNothing::CActivityNothing()_0 = 0x006182B0, 0, 0, 0

CActivityNothing CActivityNothing::CActivityNothing(
);

;=======================================================
; class CActivityMoveCommandToward
;=======================================================

#label CActivityMoveCommandToward::CActivityMoveCommandToward()_0 = 0x00618550, 0, 0, 0
#label CActivityMoveCommandToward::Perform()_virtual_2 =  0x00618660, 0, 0, 0

CActivityMoveCommandToward CActivityMoveCommandToward::CActivityMoveCommandToward(
);

UNKNOWN CActivityMoveCommandToward::Perform(
 UNKNOWN Param1,
 UNKNOWN Param2
);

;=======================================================
; class CActivityMoveHintWander
;=======================================================

#label CActivityMoveHintWander::CActivityMoveHintWander()_0 = 0x006186D0, 0, 0, 0

CActivityMoveHintWander CActivityMoveHintWander::CActivityMoveHintWander(
);

;=======================================================
; class CActivityMoveCommandStayNear
;=======================================================

#label CActivityMoveCommandStayNear::CActivityMoveCommandStayNear()_3 = 0x00618B20, 0, 0, 0

CActivityMoveCommandStayNear CActivityMoveCommandStayNear::CActivityMoveCommandStayNear(
 UNKNOWN Param1,
 UNKNOWN Param2,
 UNKNOWN Param3
);

;=======================================================
; class CActivityMoveCommandStayAway
;=======================================================

#label CActivityMoveCommandStayAway::CActivityMoveCommandStayAway()_3 = 0x00618DA0, 0, 0, 0

CActivityMoveCommandStayAway CActivityMoveCommandStayAway::CActivityMoveCommandStayAway(
 UNKNOWN Param1,
 UNKNOWN Param2,
 UNKNOWN Param3
);

;=======================================================
; class CActivityPursue
;=======================================================

#label CActivityPursue::CActivityPursue()_0 = 0x00619050, 0, 0, 0

CActivityPursue CActivityPursue::CActivityPursue(
);

;=======================================================
; class CActivityFlee
;=======================================================

#label CActivityFlee::CActivityFlee()_0 = 0x006191B0, 0, 0, 0

CActivityFlee CActivityFlee::CActivityFlee(
);

;=======================================================
; class CActivityJumpBack
;=======================================================

#label CActivityJumpBack::CActivityJumpBack()_0 = 0x006193F0, 0, 0, 0

CActivityJumpBack CActivityJumpBack::CActivityJumpBack(
);

;=======================================================
; class CActivityGetOut
;=======================================================

#label CActivityGetOut::CActivityGetOut()_0 = 0x006196B0, 0, 0, 0

CActivityGetOut CActivityGetOut::CActivityGetOut(
);

;=======================================================
; class CActivityApproach
;=======================================================

#label CActivityApproach::CActivityApproach()_0 = 0x00619C50, 0, 0, 0

CActivityApproach CActivityApproach::CActivityApproach(
);

;=======================================================
; class CActivityMoveBy
;=======================================================

#label CActivityMoveBy::CActivityMoveBy()_0 = 0x00619F70, 0, 0, 0

CActivityMoveBy CActivityMoveBy::CActivityMoveBy(
);

;=======================================================
; class CActivityVocalSnarl
;=======================================================

#label CActivityVocalSnarl::CActivityVocalSnarl()_0 = 0x0061A970, 0, 0, 0

CActivityVocalSnarl CActivityVocalSnarl::CActivityVocalSnarl(
);

;=======================================================
; class CActivityVocalCroon
;=======================================================

#label CActivityVocalCroon::CActivityVocalCroon()_0 = 0x0061AA50, 0, 0, 0

CActivityVocalCroon CActivityVocalCroon::CActivityVocalCroon(
);

;=======================================================
; class CActivityBite
;=======================================================

#label CActivityBite::CActivityBite()_0 = 0x0061ABD0, 0, 0, 0
#label CActivityBite::Perform()_virtual_2 = 0x0061AC20, 0, 0, 0x0061E400

CActivityBite CActivityBite::CActivityBite(
);

VOID CActivityBite::MainProc(
 UNKNOWN Param1,
 UNKNOWN Param2
);

#label CallsCPhysicsInfoMethodForBoundaryBox = 0x0061AE85

;=======================================================
; class CActivityFeint
;=======================================================

#label CActivityFeint::CActivityFeint()_0 = 0x0061B0E0, 0, 0, 0

CActivityFeint CActivityFeint::CActivityFeint(
);

;=======================================================
; class CActivityRam
;=======================================================

#label CActivityRam::CActivityRam()_0 = 0x0061B280, 0, 0, 0

CActivityRam CActivityRam::CActivityRam(
);

;=======================================================
; class CActivityPhased
;=======================================================

#label CActivityPhased::CActivityPhased()_1 = 0x00623850, 0, 0, 0

CActivityPhased CActivityPhased::CActivityPhased(
 UNKNOWN Param1
);

;=======================================================
; class CActivityEat
;=======================================================

#label CActivityEat::CActivityEat()_0 = 0x0061B6B0, 0, 0, 0

CActivityEat CActivityEat::CActivityEat(
);

;=======================================================
; class CActivityDrink
;=======================================================

#label CActivityDrink::CActivityDrink()_0 = 0x0061BDC0, 0, 0, 0

CActivityDrink CActivityDrink::CActivityDrink(
);

;=======================================================
; class CActivityTailSwipe
;=======================================================

#label CActivityTailSwipe::CActivityTailSwipe()_0 = 0x0061C080, 0, 0, 0

CActivityTailSwipe CActivityTailSwipe::CActivityTailSwipe(
);


;=======================================================
; class CNHInfluence
;=======================================================

#label CNHInfluence::CNHInfluence()_1 = 0x0061F060, 0, 0, 0

CNHInfluence CNHInfluence::CNHInfluence(
 UNKNOWN Param1
);

5 inst.

;=======================================================
; class CNHInfluenceSurface
;=======================================================

#label CNHInfluenceSurface::CNHInfluenceSurface()_1 = 0x0061F140, 0, 0, 0

CNHInfluenceSurface CNHInfluenceSurface::CNHInfluenceSurface(
 UNKNOWN Param1
);

;=======================================================
; class CNHNodeSource
;=======================================================

#label CNHNodeSource::CNHNodeSource()_1 = 0x0061F220, 0, 0, 0

CNHNodeSource CNHNodeSource::CNHNodeSource(
 UNKNOWN Param1
);

5 inst.





