
;=======================================================
#label OnExitWrap()_1 = 0x00609097
;=======================================================
BOOL OnExitWrap(
 DWORD OnExitParam
);

If DWORD [0073D1E4h] = -1, calls MSVCRT._onexit,
Otherwise calls MSVCRT.__dllonexit
Passes OnExitParam as first param to whichever is called.
__dllonexit uses extra params, DWORD 0073D1E0h and 0073D1E4h.
BOOL returned is based on whichever call's return value.

;=======================================================
#label RTDynamicCastWrap()_5 = 0x0060911C
;=======================================================
DWORD RTDynamicCastWrap(
 UNKNOWN Param1,
 UNKNOWN Param2,
 UNKNOWN Param3,
 UNKNOWN Param4,
 UNKNOWN Param5
);

Jumps directly to MSVCRT.__RTDynamicCast




;=======================================================
;NOTE: NoAction() procedures/methods are not given
;unique labels unless necessary.
;=======================================================

;=======================================================
#label NoAction()_var = 0x004672E0
;=======================================================
VOID NoAction(
);

Does:
ret

;=======================================================
#label NoAction()_var = 0x00468A60
;=======================================================
VOID NoAction(
);

Does:
ret

;=======================================================
#label NoAction()_var = 0x004B0780
;=======================================================
VOID NoAction(
);

Does:
ret

;=======================================================
#label NoAction()_var = 0x00527490
;=======================================================
VOID NoAction(
);

Does:
ret

;=======================================================
#label NoAction()_var = 0x00609333
;=======================================================
VOID NoAction(
);

Does:
ret

;=======================================================
#label NoAction()_stdcall_2 = 0x00403270
;=======================================================
VOID NoAction(
 DWORD Unused1,
 DWORD Unused2
);

Does:
ret 8

Note: May also be used for unimplemented method calls,
not just stdcalls.

;=======================================================
#label NoAction()_stdcall_1 = 0x005EEDF0
;=======================================================
VOID NoAction(
 DWORD Unused1
);

Does:
ret 4

Note: May also be used for unimplemented method calls,
not just stdcalls.

;=======================================================
#label NoAction()_stdcall_3 = 0x00403400
;=======================================================
VOID NoAction(
 DWORD Unused1,
 DWORD Unused2,
 DWORD Unused3
);

Does:
ret 0Ch

Note: May also be used for unimplemented method calls,
not just stdcalls.

;=======================================================
#label NoAction()_stdcall_4 = 0x00418200
;=======================================================
VOID NoAction(
 DWORD Unused1,
 DWORD Unused2,
 DWORD Unused3,
 DWORD Unused4
);

Does:
ret 10h

Note: May also be used for unimplemented method calls,
not just stdcalls.

;=======================================================
#label NoActionReturnParam2()_2 = 0x0052C530
;=======================================================
DWORD NoActionReturnParam2(
 UNKNOWN Param1,	// sometimes 0
 UNKNOWN Param2
); // returns Param2

Called in presence of such classes as CLightAmbient
and CRasterMem.

;=======================================================
#label CObject::NoAction()_virtual_1 = 0x00467120
;=======================================================
VOID CObject::NoAction(
 UNKNOWN Param1
);

;=======================================================
#label CObject::NoActionReturnFalse()_virtual_0 = 0x004685E0
;=======================================================
BOOL CObject::NoActionReturnFalse(
); // returns FALSE

Does:
xor al,al
ret

;=======================================================
#label CObject::NoActionReturnFalse()_virtual_0 = 0x005ED720
;=======================================================
BOOL CObject::NoActionReturnFalse(
); // returns FALSE

Does:
xor al,al
ret

;=======================================================
#label CObject::NoActionReturn0x28()_virtual_0 = 0x0045BFD0
;=======================================================
DWORD CObject::NoActionReturn0x28(
); // returns 28h

Does:
mov eax,28h
ret

;=======================================================
#label CObject::NoActionReturnTrue()_virtual_0 = 0x005F3780
;=======================================================
BOOL CObject::NoActionReturnTrue(
); // returns 1

Does:
mov al,1
ret

;=======================================================
#label CObject::NoActionFalse()_virtual_1 = 0x0045DCD0
;=======================================================
BOOL CObject::NoActionFalse(
 UNKNOWN Param1
); // returns FALSE

Does:
xor al,al
ret 4

;=======================================================
#label CObject::NoActionReturnParam1()_virtual_1 = 0x004F2F80
;=======================================================
DWORD CObject::NoActionReturnParam1(
 UNKNOWN Param1
); // returns Param1

Does:
mov eax,[esp+4]
ret 4


;=======================================================
#label CObject::ReturnEntityString()_virtual_0 = 0x005FA130
;=======================================================
LPCTSTR CObject::ReturnEntityString(
); // always returns pointer to string "Entity"

;=======================================================
#label CObject::ReturnInstanceString()_virtual_0 = 0x005F7BB0
;=======================================================
LPCTSTR CObject::ReturnInstanceString(
); // always returns pointer to string "Instance"



;=======================================================
#label CObject::SetToDWORDNullAndReturnParam1()_virtual_1 = 0x00471A30
;=======================================================
LPDWORD CObject::SetToDWORDNullAndReturnParam1(
 LPDWORD Param1
); // return Param1

;=======================================================
#label TPartitionList::TPartitionList()_0 = 0x005FCE40
;=======================================================
TPartitionList TPartitionList::TPartitionList(
);


;=======================================================
#label RegSaveDWORDToGameKey()_2 = 0x005DAD50
;=======================================================
DWORD RegSaveDWORDToGameKey(
 LPCTSTR lpValueName,
 DWORD ValueToSet
); // keeps return value of RegSetValueEx

;=======================================================
#label RegGetDWORDFromGameKey()_2 = 0x005DAD70
;=======================================================
DWORD RegGetValueFromGameKey(
 LPCTSTR lpValueName,
 DWORD DefaultValue
); // Returns value if found or default value otherwise


;=======================================================
#label RegSaveStringToGameKey()_2 = 0x005DADC0
;=======================================================
DWORD RegSaveStringToGameKey(
 LPCTSTR lpValueName,
 LPCTSTR lpString
); // keeps return value of RegSetValueEx


;=======================================================
#label RegGetStringFromGameKey()_4 = 0x005DADF0
;=======================================================
INT RegGetStringFromGameKey(
 LPCTSTR lpValueName,
 LPVOID lpBuffer,	// for return value
 INT BufferSize,
 LPCTSTR lpDefaultString   // this string will be returned in lpBuffer if value does not exist
); // Returns size of string returned, whether true or from default.

;=======================================================
#label RegDeleteValueFromGameKey()_1 = 0x005DAEB0
;=======================================================
DWORD RegGetStringFromGameKey(
 LPCTSTR lpValueName
); // keeps return value of RegDeleteValue




;=======================================================
; class CRandom
;=======================================================

#label CRandom::SeedRandom()_1 = 0x005DA5A0
#label CRandom::GetRandomValue32()_0 = 0x005DA600

CRandom CRandom::SeedRandom(
 DWORD SeedValue
);

Uses MSVCRT.srand and MSVCRT.rand to fill CRandom
structures with random values.

DWORD CRandom::GetRandomValue32(
); // Returns 'next' random value

Called at least once, during level load.


;=======================================================
; class CTimerLocal
;=======================================================

#label CTimerLocal::CTimerLocal()_0 = 0x005DCE40, 0, 0, 0
#label CTimerLocal::UpdateCurrentTick()_0 = 0x005DCE60, 0, 0, 0

CTimerLocal CTimerLocal::CTimerLocal(
);

DWORD CTimerLocal::UpdateCurrentTick(
); // returns some tick value and updates timer values




