;CParticles default color changer

;[obj]          = VTable
;[obj+4]        = n/a
;[obj+8]        = particle's encrypted name ID
;[obj+12]       = color to use

struct CAT109
       lpVTable 		dd	?
       refCount 		dd	?
       ParticleNameID		dd	?
       Color			dd	?
ends

align 16
;==========================================================
AT109MAIN:
;==========================================================
push esi
mov esi,ecx

;/* CHECK IF WE ARE MODIFYING ONE OF THE 7 DEFAULT PARTICLE TYPES

     mov edx,[esi+8]
     call CParticlesFindTypeIDInTable
     cmp eax,-1
	 jz NoAT109MAINNightModeCheck

     mov edx,[esi+12]			;new color
     mov [CPAT109Color+eax],edx       ;change color in buffer only so that NIGHT modifications apply

     ;call CParticlesColorGlobalUpdate    ;because should only be used during level load (CStartTrigger)
					  ;this will only be called at ENDLEVELLOAD

pop esi
ret
;*/

NoAT109MAINNightModeCheck:

     stdcall [CPARTICLESGETOBJPROC],[esi+8],0	  ;this returns a pointer to a CParticles data structure (if existing)
     add esp,8					  ;corresponding the particle type name ID passed as first param
     test eax,eax
     mov edx,[esi+12]			;new color
	  jz AT109MAIN_ERROR

     mov [eax+4],edx			;update color

AT109MAIN_ERROR:
pop esi
ret

align 16
;==========================================================
AT109_REINIT:		     ;APPLY THIS ACTIONTYPE AT ANY LEVEL RESTART OR LOAD
;==========================================================
     call AT109MAIN

mov eax,[esp+4]
ret 4

align 16
;====================================================================
_AT109Init:
;====================================================================
GETVALUE Sample,0		;get particle name
sub esp,4
mov edi,esp
SETVALUE value_string,1
pop edi 			;edi=pointer to string (if valid)
test eax,eax
     jz NoNewActionType 	;leave if no valid string

push edi
call [CPARTICLESENCNAMEPROC]	;get "encrypted" particle name (ID)
mov ebx,eax
add esp,4

ALLOCAT 16
lea eax,[AT109]
xor ecx,ecx
mov [edi],eax
mov [edi+4],ecx
mov [edi+8],ebx 		    ;particle ID
mov [edi+12],ecx		    ;color

GETVALUE R_tscriptvalue,1
SETVALUE2 value_int		    ;(in eax)
	shl eax,16		    ;XXRR0000h
	mov esi,00FF0000h
	and esi,eax

GETVALUE G_tscriptvalue,2
SETVALUE2 value_int		    ;(in eax)
	shl eax,8		    ;00RRGG00h
	and eax,0000FF00h
	or esi,eax

GETVALUE B_tscriptvalue,3
SETVALUE2 value_int		    ;(in eax)
	and eax,000000FFh
	or esi,eax		    ;00RRGGBBh
	mov [edi+12],esi	    ;final color value

	jmp ExitINAT