;========================================================
;GENERAL DATA
;========================================================
;(lots of wasted spaced, but the file's not huge anyhow)

StringBuffer	    db	    512 dup 0	  ;storage for EXE name and root Trespasser folder (faster if static)
PathStringSize	    dd	    0
MapsDirBuffer	    db	    512 dup 0	  ;root Trespasser folder + 'MAPS\' subfolder
MapsPathSize	    dd	    0
DDF_FN_Buffer	    db	    512 dup 0	  ;used for DDF (same as MapsDirBuffer)
ATXconfiginiFN	    db	    512 dup 0	  ;full ATXconfig.ini filename and path

WindowName	    db	    "Trespasser",0
WindowClassName     db	    "DWI - Trespasser",0
ATXCONFIGFN	    db	    "ATXconfig.ini",0

SAVEGAMENAME_STR    db	    "SAVEGAME.%.3u",0

ATX_title_main	    db	    "ATX Exit Error",0
ATX_rv_warning	    db	    "Warning! Video recording halted prematurely.",0Dh,0Ah
		    db	    "Please restart your computer.",0

_integer	    db	    "%i",0	  ;for MSVCRT calls (if present)
_float		    db	    "%f",0
_unint		    db	    "%u",0

system_info_buf     SYSTEM_INFO
find_data_buf	    FINDDATA

align 16
stack_ext_buffer    dd	    1000 dup 0	      ;may be used instead of large amounts of local
					     ;stack variables, to prevent stack overflows
					     ;(may be referred to from high address as standard stack
					     ; or from low address as buffer, depending on procedures)


GetTickCount			dd	 GetTickCountINGAME
LevelStart_TICK 		dd	 0

VirtualProtectEx		dd	 0
UseOldVirtualProtectFunction	dd	 0

CAnimationsCMessageStepMethod	dd	 0


;========================================================
include 'Errors.inc'
;========================================================

DisableInGameMouseMvt	    db	    FALSE
Restart_Exit_Level_BOOL     db	    0

align 4
CAnimalBuffer		    dd	    0		  ;holds pointers to all CAnimal objects and all CAnimal ATX info
CAnimalBufferEnd	    dd	    0		  ;always valid and non-zero when CAnimalBuffer is not null
CAnimalBufferSize	    dd	    0		  ;always valid and non-zero when CAnimalBuffer is not null
CAnimal_JUMP_Info_BUF	    dd	    0
CAnimal_Intance_Count	    dd	    0

TempMessageTime 	    dd	    0
TempMessageString	    dd	    0
TempMessageParam1	    dd	    0
TempMessageParam2	    dd	    0
TempMessageParam3	    dd	    0
TempMessageParam4	    dd	    0

;========================================================
;DirectDraw data
;========================================================
PrimarySurfaceDC	dd	0
PrimarySurfaceObj	dd	0
Effects_BOOL		dd	0	;bit0 = effect1, bit1 = n/a

lpDDBltFx		DDBLTFX
;DDSurface_Temp          DDSURFACEDESC2

;========================================================
;instance location randomization values
;========================================================
EMPTY_STRING		db	0
NONE_STRING		db	"none",0
NULL_STRING		db	"NULL",0
ZERO_STRING		db	"0",0
FLOAT_RETRIEVE_STRING	db	"%f, %f, %f",0
FLOAT_RETRIEVE_STRING_6 db	"%f, %f, %f, %f, %f, %f",0
MAIN_SECTION		db	"Instances",0
ENTRIES_STRING		db	"Entries",0
ENTRY_COUNT		db	"NumberOfENTRYSections",0
INSTANCE_STRING 	db	"Instance%u",0
RESERVE_STRING		db	"Reserve%u",0
ENTRY_STRING		db	"ENTRY%u",0
LOCATION_STRING 	db	"Location%u",0
STAYNEARMAX_STRING	db	"ForceStayNearMax",0
STAYNEAROK_STRING	db	"ForceStayNearOK",0
WAKEUP_STRING		db	"ForceWakeUp",0
SLEEP_STRING		db	"ForceSleep",0
NOGETOUT_STRING 	db	"DisableActGetOut",0
NORMALMODELOC_STRING	db	"NormalModeLoc%u",0
NIGHTMODELOC_STRING	db	"NightModeLoc%u",0
AXX_STRING		db	"A%0.2d",0
SEMICOLONS_3_STRING	db	"%u; %u; %u;",0
SINGLESTRING_STRING	db	"%s",0

;buffers used during initialization (unfortunately, cannot be in local
;memory due to stack overflows or such)
RAND_BUF1		db	200 dup 0
RAND_RSRV_ENTRY_BUF	db	200 dup 0
RAND_INST_NAME_BUF	db	200 dup 0
RAND_LOC_STR_BUF	db	200 dup 0

;========================================================
;CANIMAL cheat data
;========================================================
canimal_title_base	db	"CAnimal Info (%u instances):",0
canimal_title_size	dd	0
canimal_title		db	55 dup 0
canimal_base_addr	db	"Base Address: 0x%.8X",0
canimal_pos		db	"Location: %.2f, %.2f, %.2f",0
canimal_health		db	"HitPoints: %.2f",0
canimal_maxhealth	db	"MaxHitPoints: %.2f",0
canimal_bravery 	db	"Bravery: %.5f",0
canimal_jumpinfo	db	"ActJumpNew info: %.2f, %.2f, %u, %u, %u, %u, %u",0
canimal_sleepwakeup	db	"Sleep & WakeUp: %.5f, %.5f",0

canimal_emos_text_table:
	dd canimal_fear,canimal_love,canimal_anger,canimal_curiosity
	dd canimal_hunger,canimal_thirst,canimal_fatigue,canimal_pain
canimal_emos_text_table_end:

canimal_emos_offsets_table:	   ;offsets from main AI class
	dd 4h,8h,0Ch,10h
	dd 14h,18h,1Ch,20h

canimal_anger		db	"Anger: %.5f",0
canimal_curiosity	db	"Curiosity: %.5f",0
canimal_fatigue 	db	"Fatigue: %.5f",0
canimal_fear		db	"Fear: %.5f",0
canimal_hunger		db	"Hunger: %.5f",0
canimal_love		db	"Love: %.5f",0
canimal_thirst		db	"Thirst: %.5f",0
canimal_pain		db	"Pain: %.5f",0

DisplayDinoInfo_BOOL	db	0
DisplayDino_INDEX	dd	0
ShowPlayerHealth_BOOL	db	0

ShowDinosOnMap_BOOL		db	0
ShowActiveDinoOnMap_BOOL	db	0

ShowFaceFloats_BOOL		db	0
ShowFaceFloat_STRING		db	"Player face values (wxyz): %.5f, %.5f, %.5f, %.5f",0
ShowFaceFloat_AA_STRING 	db	"Angle (rad) & Axis (xyz): %.5f, %.5f, %.5f, %.5f",0
ShowPlayerHealth_STRING 	db	"Player HitPoints & MaxHitPoints: %.5f, %.5f",0

;========================================================
;other
;========================================================

align 4
;FLAGS/VALUES
UseWINDOWED		    dd	    0
UseGRAVITY		    dd	    0
UseDRAWDISTANCE 	    dd	    0
UseTRESSTRDBG		    dd	    0
UseDEMOHACK		    dd	    0
UseNoGetOut		    dd	    0
UseNoStayNear		    dd	    0
UseNoStayAway		    dd	    0
UseSleepWake		    dd	    0
UseDisableSWPDelete	    dd	    0
UseCAnimalHitPoints	    dd	    0
UseRandomInstanceLocations  dd	    0
UseDisableActJumpNew	    dd	    0
UseDisableQuadrupedJumps    dd	    0

UseDrawDistSubKey	    dd	    0
UseDrawDistAddKey	    dd	    0
UseMXTRadius		    dd	    0
MXTRadiusEXP2		    dd	    0

UseToggleNewKeys	    dd	    0
ToggleNewKeys_BOOL	    db	    1
ToggleKeys_FORCED_BOOL	    db	    0
ToggleKeysShowStateTime     dd	    0

;troubleshooting
UseDisableA3Ddll	    dd	    0
UseHighResolutionsHack	    dd	    0

SDBGDUMPFILE		    db	    "C:\SDBG_DUMP.txt",0

RT_ERROR_COUNT		    dd	    0
LAST_ERROR_TIME 	    dd	    0
ErrorCountDisplayString     db	    "ATXTres Error Detected (Total: %u)",0

FPS_framecount		    dd	    0
FPS_lastframetime	    dd	    0
FPS_toggle		    db	    0
FPS_string		    db	    "FPS: %.2f",0
FPS_lastfps		    dq	    0

;========================================================
;VARIOUS STORED FLOATS
;========================================================

align 4
float_0 		dd	0.000000
float_minusone		dd	-1.000000
float_0_5		dd	0.500000
float_0_5_B		dd	0.500000
float_5 		dd	5.000000
pidivtwo		dd	1.5707963267948966192313216916398
pi			dd	3.1415926535897932384626433832795
pi2			dd	6.28318530717958647692528676655901
minuspi2		dd	-6.28318530717958647692528676655901
pidiv180		dd	0.0174532925199432957692369076848861
d180divpi		dd	57.2957795130823208767981548141052
float_100		dd	100.000000
float_15		dd	15.000000
float_1000		dd	1000.000000
float_0_001		dd	0.001000
float_0_0005		dd	0.0005
float_1div255		dd	0.00392156862745098039215686274509804
float_gravdivtwo	dd	5.000000
float_sqrt_0_5		dd	0.70710678118654752440084436210485
cam2d_depth_check	dd	1.000000	;if z depth value below this, do not render
cam2d_minwh_check	dd	-20000.000000	;if raw x or y value below this, do not render
cam2d_maxwh_check	dd	20000.0000000	;if raw x or y value above this, do not render
cam2d_maxwh_recipr	dd	0.00005 	;1/20000

align 8
float_two		dd	2.000000
			dd	2.000000
float_one		dd	1.000000
			dd	1.000000
Quat_NormalizeCheck_CmpValue		dd	 0.001	     ;if abs(1-quat magnitude) below or equal to this value, no normalization
					dd	 0.001	     ;-> value 0.001 is taken from game, used in its own quat multiplication function
Float_AND_3DNow_AbsoluteValueMask	dq	 07FFFFFFF7FFFFFFFh

;========================================================
;MAP cheat data
;========================================================
MapIndex		    db	    "MapIndex.ini",0
STRING_Bitmap		    db	    "Bitmap",0
STRING_BMPDEF		    db	    "DEF",0
STRING_X1		    db	    "X1",0
STRING_Y1		    db	    "Y1",0
STRING_X2		    db	    "X2",0
STRING_Y2		    db	    "Y2",0
BMPMAPNAME_BUF		    db	    150 dup 0
MapLoadSuccess_BOOL	    db	    FALSE

;========================================================
;ActionType data
;========================================================

;AT102
AT102EMULATEDOBJECT:
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    1	;1 for direct BMP name ref (not relative to buffer)

;current bitmap values /*
anchorXvalue	    dd	    0
anchorYvalue	    dd	    0
scaleXvalue	    dd	    0
scaleYvalue	    dd	    0

currentbitmap	    dd	    0
bitmapheight	    dd	    0
bitmapwidth	    dd	    0
;                       */

USE_MAP 	    db	    0
USE_LOC 	    db	    0
LastTickCount	    dd	    0
Show_Blinker	    db	    1

SAVED_MAP_BUFFER    db	    80 dup 0
		    db	    0		;"insurance" null-terminator
CURRENT_MAP_BUFFER  db	    80 dup 0
		    db	    0		;"insurance" null-terminator
CURRENT_MAP_VALUES  dd	    4 dup 0

SAVEGAMENAME_BUFFER  db     256 dup 0

SAVED_MAP_OBJECT:
		    dd	    0
		    dd	    0
		    dd	    SAVED_MAP_BUFFER
SAVED_MAP_X1	    dd	    0
SAVED_MAP_Y1	    dd	    0
SAVED_MAP_X2	    dd	    0
SAVED_MAP_Y2	    dd	    0
		    dd	    1		;1 for direct BMP name ref

IsInGame_BOOL			db	0
IsInConsole_BOOL		db	0
NotInGame_BOOL			db	0
NotInGameStart_TICK		dd	0
NotInGameEnd_TICK		dd	0
NotInGame_TOTALMENUTIME 	dd	0

DrawDistDisplayTime		dd	0
DrawDistDisplayString		db	"Draw Distance: %2f",0

AT19EMULATEDOBJECT:	  ;36 bytes (basically same as AT16 class)
		dd	 0	;VTable
		dd	 0	;RefCount
		dd	 0	;name string length
		dd	 010h	;???
		dd	 4 dup 0    ;storage for names shorter than 16 bytes
		dd	 0	;pointer to name string (to previous buffer if less than 16 bytes)

;========================================================
;counter data
;========================================================
CounterFirstRun     dd	    0
USE_COUNTER	    dd	    0
FirstTimeStamp	    dd	    0
Time_Format_String  db	    "Time: %.2u:%.2u:%.2u",0


;========================================================
;HACKED CONSOLE VARIABLES
;========================================================

STRING_LOC		    db	"LOC",0
STRING_DINOS		    db	"DINOS",0
STRING_BIONICWOMAN	    db	"BIONICWOMAN",0
STRING_INVUL		    db	"INVUL",0
STRING_WOO		    db	"WOO",0

DEFINENEWCHEATS Cheattable,NewCheattableMembers,EndNewCheattableMembers,\
		CHEATJUMPINDEX,NEWCHEATSINDEX,ENDNEWCHEATSINDEX,\
		CheatHotKeyTableRT,\
		MAP		, DISPLAYMAPCONSOLE		,\
		TIME		, DISPLAYCOUNTER		,\
		RESET		, RESETCOUNTER			,\
		CANIMAL 	, DISPLAYDINOINFO		,\
		B		, CYCLEDINOINFOLEFT		,\
		N		, CYCLEDINOINFORIGHT		,\
		KILL		, KILLACTIVEDINO		,\
		MDINO		, SHOWDINOSONMAP		,\
		MSEL		, SHOWACTIVEDINOONMAP		,\
		HEALDINO	, HEALACTIVEDINO		,\
		TESTCHEAT	, TESTCHEATCODE 		,\
		CLOAK		, CHANGEPLAYERTYPE		,\
		FAC		, SHOWPLAYERFACEFLOATS		,\
		FLY		, ENABLEFLYCHEAT		,\
		KILLALL 	, KILLALLDINOS			,\
		TELEDINO	, TELEPORTDINOCHEAT		,\
		REC		, VIDEOCAPTURETOGGLE		,\
		PLAYERHEALTH	, SHOWPLAYERHEALTH		,\
		FPS		, TOGGLEFPSDISPLAY		,\
		SUPERHP 	, SETHIGHHPVALUE		,\
		NORMALHP	, SETNORMALHPVALUE		,\
		SHOWDD		, SHOWTEMPDRAWDIST_CHEAT	,\
		DRV		, TOGGLEDRVOBJPOSDISPLAY	,\
		LOAD		, DOLEVELLOADCHEAT		,\
		BUFSIZE 	, TOGGLEBUFSIZEDISPLAY		,\
		OBJ		, OBJCHEATTOGGLE		,\
		FOLLOWDINO	, FOLLOWDINOCHEATTOGGLE 	,\
		THIRDP		, TOGGLETHIRDPCHEAT		,\
		AIM		, TOGGLETHIRDPAIMCHEAT		,\
		OBJN		, OBJNCHEATTOGGLE		,\
		OBJF		, OBJFCHEATTOGGLE		,\
		CDINO		, SELECTCLOSESTDINO		,\
		GSPD		, TOGGLEGSPDDISPLAY		,\
		LINST		, TOGGLELINSTDISPLAY		,\
		COUTP		, COUTPPRINTINITIATECOMMAND	,\
		COUTPCNT	, COUTPSHOWINSTANCECOUNTCOMMAND ,\
		FLYTELE 	, TELEPORTPLAYERTOFLYLOCATION	,\
		OBJAIM		, OBJUSEFROMAIMTOGGLE		,\
		HUD		, TOGGLEHUDDISPLAY		,\
		TRACES		, TOGGLEPATHTRACESDISPLAY	,\
		USEOBJ		, USEOBJCURRENT 		,\
		SUICIDE 	, KILLANNECOMMAND		,\
		TEST		, TESTCHEATCODE

TotalCheats	dd	0
OriginalCheats	dd	0

;========================================================
;FLY MODE VALUES/VARS
;========================================================

UseFlySpeed		dd	0
UseFlySpeed_ORIG	dd	0
UseFlyKeyDelay		dd	0
UseFlyKeyDelay_RECIPR	dd	0

FlySpeedTemp		dd	0
FlySpeedTemp_Fast	dd	0

Key_Last_Recorded_Time	dd	0

LastXPostion_FLY	dd	0	;only these need to be updated
LastYPostion_FLY	dd	0	;when cheat is enabled
LastZPostion_FLY	dd	0

Temp_Fly_Buffer 	dd	8 dup 0    ;3 position values, 4 for quats, 1 for bools
Temp_Fly_Buffer2	dd	3 dup 0
Temp_Fly_Buffer3:
	dd 0
	dd 03F800000h
	dd 0

DefaultKeyBOOLS:	;from "KeyMap" reg key/exe key list
	dd	00000040h
	dd	00000080h
	dd	00000010h
	dd	00000008h
	dd	00000020h
	dd	00000001h
	dd	00000002h
	dd	00000100h
	dd	00000400h
	dd	00000200h
	dd	01000000h
	dd	02000000h
	dd	04000000h
	dd	08000000h
	dd	10000000h
DefaultKeyBOOLS_END:

FLY_Exit_Queued_BUF	dd	7 dup 0
FLY_Exit_Queued_BOOL	db	0

FLY_MODE_BOOL		db	0

;========================================================
;ACTIONTYPE/DINO JUMP (ActJumpNew) DATA/BUFFERS
;========================================================
align 4
AT10_SIM_OBJECT 	db	(64+16) dup 0	  ;VTable set in INI init code include fil

AT10_EMITTER_SIM_OBJECT db	100 dup 0

AT10_SIM_OBJECT_VELONLY db	40h dup 0	  ;assumed all values null except refcount, x,y,z velocities and target instance
AT16_SIM_OBJECT 	db	(24h) dup 0
AT18_SIM_OBJECT 	db	(2Ch) dup 0

STRING_GENERAL			db	"General",0
STRING_PUSH			db	"Push",0
STRING_JUMPANGLE		db	"JumpAngle",0
STRING_JUMPTENDANCY		db	"JumpTendancy",0
STRING_REPEATPERIOD		db	"RepeatPeriod",0
STRING_TENDANCYCHECKPERIOD	db	"TendancyCheckPeriod",0

STRING_MaxBodyTargetDirAngle	db	"MaxBodyTargetDirAngle",0
STRING_MaxHeadTargetDirAngle	db	"MaxHeadTargetDirAngle",0
STRING_MinTotalVelocity 	db	"MinTotalVelocity",0
STRING_MinDirectionalVelocity	db	"MinDirectionalVelocity",0
STRING_MaxDirVelocityAngle	db	"MaxDirVelocityAngle",0
STRING_MinTargetDistance	db	"MinTargetDistance",0
STRING_MaxTargetDistance	db	"MaxTargetDistance",0

;default values
Push_INIdef			db	50 dup 0
JumpAngle_INIdef		db	50 dup 0
JumpTendancy_INIdef		dd	0
RepeatPeriod_INIdef		dd	0
TendancyCheckPeriod_INIdef	dd	0

MaxBodyTargetDirAngle_INIdef	db	50 dup 0
MaxHeadTargetDirAngle_INIdef	db	50 dup 0
MinTotalVelocity_INIdef 	db	50 dup 0
MinDirectionalVelocity_INIdef	db	50 dup 0
MaxDirVelocityAngle_INIdef	db	50 dup 0
MinTargetDistance_INIdef	db	50 dup 0
MaxTargetDistance_INIdef	db	50 dup 0

;storage default values
Push_default			db	50 dup 0
JumpAngle_default		db	50 dup 0
JumpTendancy_default		dd	0
RepeatPeriod_default		dd	0
TendancyCheckPeriod_default	dd	0

MaxBodyTargetDirAngle_default	db	50 dup 0
MaxHeadTargetDirAngle_default	db	50 dup 0
MinTotalVelocity_default	db	50 dup 0
MinDirectionalVelocity_default	db	50 dup 0
MaxDirVelocityAngle_default	db	50 dup 0
MinTargetDistance_default	db	50 dup 0
MaxTargetDistance_default	db	50 dup 0

AJN_lasttest_mindist	    db	    "Last ActJumpNew test: minimum distance",0
AJN_lasttest_maxdist	    db	    "Last ActJumpNew test: maximum distance",0
AJN_lasttest_minspeed	    db	    "Last ActJumpNew test: minimum total speed",0
AJN_lasttest_minspeeddir    db	    "Last ActJumpNew test: minimum directional speed",0
AJN_lasttest_maxbodyangle   db	    "Last ActJumpNew test: max body angle",0
AJN_lasttest_maxheadangle   db	    "Last ActJumpNew test: max head angle",0
AJN_lasttest_maxspeedangle  db	    "Last ActJumpNew test: max speed angle",0
AJN_lasttest_dinojump	    db	    "Last ActJumpNew test: dino jumped",0

include 'menudata.inc'

;========================================================
GAME_DIFFICULTY_TABLE:		;4 entries per difficulty (very easy, easy, normal, hard, very hard)
	dd	  0.250000	   ;dino health multipliers (+00)
	dd	  0.750000
	dd	  1.000000
	dd	  1.500000
	dd	  2.000000

	dd	  2.000000	   ;player health multipliers (+20)
	dd	  1.300000
	dd	  1.000000
	dd	  0.700000
	dd	  0.400000

;========================================================
;TEMPORARY TEST DATA
;========================================================
Test_Main_BOOL		dd	0

;========================================================
;VIDEO RECORDING
;========================================================
align 4

vrdef_bufsize		dd	0	;(vrdef_width*vrdef_height*3) (3 -> 24 bpp)
vrdef_frametime 	dd	0	;(1000 / vrdef_framerate = milliseconds between frames)
vrdef_frametime_INT	dd	0
vrdef_frametimediv1000	dd	0	;vrdef_frametime/1000
vrdef_dibcolors 	dd	0

dibfileheader		DIBDUMPHEADER	;includes error count
VideoStartTime		dd	0
VideoEnabledBool	db	0
NewSaveMethod		dd	0
NoLowFPSComp		dd	FALSE
UseRECWriteThrough	dd	0
newsavemethodSD 	DDSURFACEDESC2	sizeof.DDSURFACEDESC2
dx_temp_memSD		DDSURFACEDESC2	sizeof.DDSURFACEDESC2
dx_temp_mem_RECT	RECT
dx_temp_mem_DDBLTFX	DDBLTFX 	sizeof.DDBLTFX
newsavetempbuffer	dd	0
DXBLT_FIRST_RUN 	db	0

NewSaveMethod_PROCTABLE:
			dd	DoScreenCopyLoop_STD
			dd	DoScreenCopyLoop_MMX
			dd	DoScreenCopyLoop_FPU
			dd	DoScreenCopyLoop_SSE
			dd	DoScreenCopyLoop_SSE2

dibtempfile_handle	dd	0
DIBBitsPointer		dd	0
framerepeatcount_BUF	dd	0
rv_mapview_temp 	dd	0
rv_temp_dc		dd	0
rv_temp_bmp_handle	dd	0
dx_temp_mem_surface	dd	0

rv_encode_success	db	"REC: Saved as "
recvideonamebuf 	db	256 dup 0

VideoElapsedTime_STR	db	"%u sec, %u/%u frames, %u rep",0
VideoDisabled_STR	db	"Video recording disabled",0

rv_no_spec_file 	db	"REC: No valid output file specified",0
rv_error_2		db	"REC E2: Insufficient memory for max frame count",0
rv_error_3		db	"REC E3: Unable to create file mapping object",0
rv_error_4		db	"REC E4: Unable to write frame repeat table",0
rv_error_5		db	"REC E5: Unable to write DIB file header",0
rv_error_6		db	"REC E6: Unable to allocate repeat buffer memory",0
rv_error_7		db	"REC E7: Unable to create DIB dump file",0
rv_error_8		db	"REC E8: Unable to write initial header",0
rv_error_9		db	"REC E9: Unable to allocate frame buffer 2",0
rv_error_A		db	"REC EA: Invalid SaveMethod number",0

rv_error_20		db	"REC E20: CreateCompatibleDC error 0x%.8X ; total: %u",0
rv_error_21		db	"REC E21: CreateDIBSection error 0x%.8X ; total: %u",0
rv_error_22		db	"REC E22: SelectObject error 0x%.8X ; total: %u",0
rv_error_23		db	"REC E23: BitBlt error 0x%.8X ; total: %u",0
rv_error_25		db	"REC E25: WriteFile error 0x%.8X ; total: %u",0
rv_error_26		db	"REC E26: Frame Copy error 0x%.8X ; total: %u",0
rv_error_27		db	"REC E27: DDraw Blt error 0x%.8X ; total: %u",0
rv_error_31		db	"REC E31: DDraw Lock surface error 0x%.8X ; total: %u",0
rv_error_28		db	"REC E28: Absent DDraw error 0x%.8X ; total: %u",0
rv_error_29		db	"REC E29: DDSurface create error 0x%.8X ; total: %u",0
rv_error_30		db	"REC E30: DDraw get pixel format error 0x%.8X ; total: %u",0

;MCI audio strings
mci_audio_capt_enabled	dd	0
mci_capt_in_progress	db	0
mcistr_open1		db	"open new type waveaudio alias atxreccapt buffer 4",0
mcistr_set1_str 	db	"set atxreccapt format tag pcm time format ms bitspersample %u "
			db	"channels %u samplespersec %u alignment %u bytespersec %u",0
mcistr_cue1		db	"cue atxreccapt input",0
mcistr_record1		db	"record atxreccapt overwrite",0
mcistr_stop1		db	"stop atxreccapt",0
mcistr_save1		db	"save atxreccapt "
mcistr_savename_buf	db	256 dup 0
mcistr_close1		db	"close atxreccapt",0

mci_bitspersample	dd	0
mci_channelcount	dd	0
mci_samplespersec	dd	0
mci_bytespersec 	dd	0

ValidSaveMethodsTable:
			dd	0
			dd	1
			dd	2
			dd	3
			dd	4
			dd	16
			dd	32
			dd	33
			dd	64
      ValidSaveMethodsTable_END:


;========================================================
;ATXDRV DATA
;========================================================
align 4

UseATXDRVEscKey 	dd	0
ATXDRV_ENABLED		dd	FALSE
ATXDRV_CURROBJ		dd	0
ATXDRV_CURRENTRTMETHOD	dd	0
ATXDRV_KeyLastTick	dd	0
ATXDRV_KeyTime		dd	0

ATXDRV_CURRVELOCITYBASE dd	0
ATXDRV_INITIALVELOCITY	atxdrv_initial_velocity
ATXDRV_INITVELVECTOR	vector
ATXDRV_INITVELVECTOR_2	vector
ATXDRV_TEMPQUAT 	quaternion
ATXDRV_TEMPQUAT2	quaternion
ATXDRV_CurrentVectorDir dd	3 dup 0
ATXDRV_CurrentVectorVal dd	0
ATXDRV_CurrentVectorVal_Saved	dd	0

ATXDRV_CURRENT		atxdrv_inst_data
ATXDRV_INITIALROTPOS	dd	7 dup 0
ATXDRV_CurrVelocity	dd	0	;front/back only, facing in same direction as object (floats/sec)
ATXDRV_CurrRotSpeed	dd	0	;current rotation speed (radian angles/sec)

ATXDRV_MvtLastTick	dd	0
ATXDRV_MvtTime		dd	0
ATXDRV_KeyPressed	db	0	;bit 0 = mvt key, bit 1 = rot key

;========================================================
;Dinosaur/Vocal
;========================================================

UseNewDinoVocals	dd	0
NewDinoVocalsBuffer	dd	0

;========================================================
;Level load cheat
;========================================================

LevelLoad_INVALID_STR	db	"LOAD: no valid *.scn file specified",0

;========================================================
;LEVELLOADBG
;========================================================

UseNewBackgroundImages	dd	0

;========================================================
;various buffer sizes
;========================================================

UseBUFSIZEInfo		db	0

BUFSIZE_rect		RECT	0,BUFSIZE_MSG,639,479

BUFSIZE_str		db	"Internal buffer sizes (bytes):",0Dh,0Ah
			db	"MAP bmp buffer: %u",0Dh,0Ah
			db	"CAnimal instance info buffer: %u",0Dh,0Ah
			db	"ActJumpNew info buffer: %u",0Dh,0Ah
			db	"New dino vocals buffer: %u",0Dh,0Ah
			db	"MAD buffer: %u"
			db	0
	BUFSIZE_str_end:

BUFSIZE_map_bitmap	dd	0
BUFSIZE_canimal_jump	dd	0
BUFSIZE_newdinovocals	dd	0

;========================================================
;OBJ CHEAT DATA
;========================================================
ObjCheatCurrentObject	dd	0
ObjCheatCurrentObject_TEMP	dd	0
ObjCheatClassTypeStr	dd	0

UseObjCheat		db	0
UseOBJAIMFunction	db	0

ObjCheat_HEX_STR	db	"%X",0
ObjOutput_1_STR 	db	"Object Base Address: 0x%.8X",0
ObjOutput_2_STR 	db	"Velocity (vector): %.5f, %.5f, %.5f",0
ObjOutput_2b_STR	db	"Velocity (total): %.5f",0
ObjOutput_3_STR 	db	"Rotation velocity: %.5f, %.5f, %.5f, %.5f",0
ObjOutput_4_STR 	db	"Location: %.5f, %.5f, %.5f",0
ObjOutput_4b_STR	db	"Distance from Player: %.5f",0
ObjOutput_5_STR 	db	"Orientation (quaternion): %.5f, %.5f, %.5f, %.5f",0
ObjOutput_6_STR 	db	"Orientation (facing/vector): %.5f, %.5f, %.5f",0
ObjOutput_7_STR 	db	"Class/VTable type: %s",0
ObjOutput_8_STR 	db	"Instance render type: %s",0
ObjOutput_9_STR 	db	"Instance mesh polygon count: %u",0
ObjOutput_A_STR 	db	"Instance mesh vertex count: %u",0
ObjOutput_B_STR 	db	"Instance mesh surface (texture) count: %u",0

ObjOutput_Err_STR	db	"OBJ error: invalid object address",0
ObjOutput_Err_2_STR	db	"No valid class type",0

ObjAim_NoObject_STR	db	"OBJAIM: No valid instance at crosshair."
ObjAim_NoObject_STR_END db	0

;========================================================
;FOLLOWDINO CHEAT DATA
;========================================================

FD_enabled	       db      0

align 4
FD_fetchfunction       dd      0
FD_tickcountinput      dd      0
FD_floattimeinput      dd      0
FD_prevcamobj1	       dd      0
FD_prevcamobj2	       dd      0

FD_mousectrlmultiplier dd      0
FD_inputinterval       dd      0       ; 1000 / keyinputrate(persecond)
FD_distance	       dd      0       ;distance between object and camera
FD_distanceoriginal    dd      0       ;distance between object and camera
FD_distancespeed       dd      0       ;floats per millisecond
FD_invertmousemul      dd      0

FD_xangle	       dd      0	      ;radians
FD_zangle	       dd      0	      ; negative -> camera pointing downward, positive -> camera pointing upward

FD_zanglemin	       dd      -1.48352986419518014038513715321532    ;radians (85 degrees)
FD_zanglemax	       dd      1.48352986419518014038513715321532

;========================================================
;THIRDP CHEAT
;========================================================

align 4
THIRDP_enabled	       db	0
THIRDP_usebaseobject   db	0
THIRDP_keyaimtoggle_ON db	0
THIRDP_playerdeadbool  db	0

THIRDP_prevcamobj1     dd	0
THIRDP_prevcamobj2     dd	0

THIRDP_inputtick       dd	0
THIRDP_inputtime       dd	0
THIRDP_inputrate       dd	0

THIRDP_keyliststart:
THIRDP_keyforward      dd	0      ;(are converted to VKs)
THIRDP_keyback	       dd	0
THIRDP_keyreset        dd	0
THIRDP_keyup	       dd	0
THIRDP_keydown	       dd	0
THIRDP_keyaim	       dd	0
THIRDP_keylistend:

THIRDP_keyaimtoggle    dd	0      ;(keep as CHAR)
THIRDP_keyaimdottoggle dd	0

THIRDP_distance        dd	0
THIRDP_distanceorig    dd	0
THIRDP_distancespeed   dd	0	  ;floats/millisecond
THIRDP_camspeed        dd	0	  ;radians/millisecond

THIRDP_camanglez       dd	0	  ;(radians)  must be limited to -85 to 85 degrees
THIRDP_camanglezorig   dd	0
THIRDP_camdispz        dd	0

THIRDP_zanglemin       dd	-1.48352986419518014038513715321532    ;radians
THIRDP_zanglemax       dd	1.48352986419518014038513715321532
THIRDP_deathcamrate    dd	1200
THIRDP_deathcamtick    dd	0

;========================================================
;CPARTICLES DATA
;========================================================

CPTypeIDTable	       CParticlesDefault
CPInitialColor	       CParticlesDefault
CPAT109Color	       CParticlesDefault
CPCurrentColor	       CParticlesDefault	;SAVE OF 7 DEFAULT GAME PARTICLE COLORS
						;(allows applying masks without losing values)
CPCurrentColorMax      CParticlesDefault	;format of each: 24-bit color 00RRGGBBh

CPSTR_Blood		db	"Blood",0
CPSTR_Bleed		db	"Bleed",0
CPSTR_Water		db	"Water",0
CPSTR_Terrain		db	"Terrain",0
CPSTR_TerrainSand	db	"Terrain - Sand",0
CPSTR_MetalHard1	db	"Metal Hard 1",0

;========================================================
;AT05 FOG DATA
;========================================================
AT05FOGMAINPROCADDR	dd	0
FogColor_saved		dd	0	     ;NOT NECESSARILY always valid, though assumed to be
					     ;(will not be if level has no AT05 upons CStartTrigger)
FogTempObj		dd	6 dup 0      ;VTable stored at ATYPEX.dll load

AT05FogWithColorModRunOnceInLevel   db	    FALSE

DEFAULT_FOG_COLOR_VALUE 	     dd      0
DISABLE_GAME_FOG		     dd      0
FogSettings_ForcedFogPowerValue      dd      0
FogSettings_ForcedFogHalfValue	     dd      0

;========================================================
;AT06 RENDERER DATA AND FOV ADJUST
;========================================================
AT06RENMAINPROCADDR	dd	0

RenderTempObj		dd	15 dup 0
RenderTempObj2		dd	15 dup 0

AT06_CameraFOV_Value	dd	0

;========================================================
;AT13 SKY DATA
;========================================================
AT13SKYMAINPROCADDR	dd	0

SkyTempObj		dd	10 dup 0

;========================================================
;NIGHT MODE DATA
;========================================================
;Night level mode is spread across CParticles color change,
;AT05 Fog color change, AT13 Sky fog distances change,
;Global clut default values change, and pre-level load code.

NIGHT_enabled			dd	0
NIGHT_enabled_last		dd	0
NIGHT_FogNearCurrent		dd	0
NIGHT_FogFarCurrent		dd	0
NIGHT_FogColorCurrent		dd	0
NIGHT_CParticlesColorMax	dd	0
NIGHT_CParticlesTypes		dd	0
NIGHT_DefaultGlobalClutStart	dd	0
NIGHT_DefaultGlobalClutStop	dd	0
NIGHT_AmbientLight		dd	0	  ;-1.000000 for not applicable
NIGHT_SkyHeight 		dd	0
NIGHT_FogPower			dd	0	  ;-1.000000 for not applicable
NIGHT_FogHalf			dd	0	  ;-1.000000 for not applicable

;========================================================
;FAST LOAD DISABLE DATA
;========================================================

DisableFastLoad 		dd	FALSE	      ;(constant)
NewGRFLoadDetected		db	TRUE

;========================================================
;ATX 3DNOW/SSE OPTIMIZATION-RELATED DATA
;========================================================

align 4
UseATX3DNowOpts 		dd	0
UseATXSSEOpts			dd	0
UseOptimizedQuaternionMulProc	dd	TRUE
UseOptimizedSSETresProcs	dd	TRUE

;function calls
;first function = std function
;second function = 3DNow! equivalent (null if not implemented)

PTRPROCTABLESTART:

PTRQuaternionMul		   dd	   QuaternionMul_STD,			   QuaternionMul_3DNOW, 		   0
PTRToLocalQuat_AxisX		   dd	   ToLocalQuat_AxisX_STD,		   0,					   0
PTRToLocalQuat_AxisY		   dd	   ToLocalQuat_AxisY_STD,		   0,					   0
PTRToLocalQuat_AxisZ		   dd	   ToLocalQuat_AxisZ_STD,		   0,					   0
PTRToLocalQuat_AxisX_NoNorm	   dd	   ToLocalQuat_AxisX_NoNorm_STD,	   0,					   0
PTRToLocalQuat_AxisY_NoNorm	   dd	   ToLocalQuat_AxisY_NoNorm_STD,	   0,					   0
PTRToLocalQuat_AxisZ_NoNorm	   dd	   ToLocalQuat_AxisZ_NoNorm_STD,	   0,					   0
PTRQuatToAxisAngle		   dd	   QuatToAxisAngle_STD, 		   0,					   0
PTRNormalizeQuat		   dd	   NormalizeQuat_STD,			   NormalizeQuat_3DNOW, 		   0
PTRCONVERT_TO_FACING_PROC_2A	   dd	   CONVERT_TO_FACING_PROC_2A_STD,	   0,					   0
PTRCONVERT_TO_FACING_PROC_010	   dd	   CONVERT_TO_FACING_PROC_010_STD,	   CONVERT_TO_FACING_PROC_3DNOW_010,	   0
PTRVectorDotProduct		   dd	   VectorDotProduct_STD,		   0,					   0
PTRFDConvAnglesToQuat		   dd	   FDConvAnglesToQuat_STD,		   0,					   0
PTRFacingRad2CompToVector_Sub	   dd	   FacingRad2CompToVector_Sub_STD,	   0,					   0
PTRToLocalQuat_NoNorm		   dd	   ToLocalQuat_NoNorm_STD,		   0,					   0
PTRVectorNormalize		   dd	   VectorNormalize_STD, 		   VectorNormalize_3DNOW,		   0
PTRQuaternionMulLocalQ2AxisX	   dd	   QuaternionMulLocalQ2AxisX_STD,	   QuaternionMulLocalQ2AxisX_3DNOW,	   0
PTRVectorMagnitude		   dd	   VectorMagnitude_STD, 		   0,					   0
PTRVectorToQuaternion		   dd	   VectorToQuaternion_STD,		   0,					   0
PTRToLocalQuat_AxisMinusX_NoNorm   dd	   ToLocalQuat_AxisMinusX_NoNorm_STD,	   0,					   0
PTRToLocalQuat_AxisMinusY_NoNorm   dd	   ToLocalQuat_AxisMinusY_NoNorm_STD,	   0,					   0
PTRToLocalQuat_AxisMinusZ_NoNorm   dd	   ToLocalQuat_AxisMinusZ_NoNorm_STD,	   0,					   0
PTRObjVectorDisplace		   dd	   0,					   0,					   ObjVectorDisplace_SSE

PTRPROCTABLEEND:

;========================================================
;AT106 LOAD NEW HINT DATA
;========================================================

HINT_RETURN_ADDR		dd	0
HINT_NEW_STRING_ADDR		dd	0

;========================================================
;OBJN AND OBJF CHEATS DATA
;========================================================

OBJN_instance			dd	0	      ;This should always hold the same instance
						      ;as [ObjCheatCurrentObject], but used under different circumstances
ObjNOutput_Err_STR	 db	 "OBJN error: object does not exist",0

;========================================================
;THIRDPAIM CHEAT
;========================================================
align 4
THIRDPAIM_enabled	  db	   0
;THIRDAIM_accmultiplier    dd       100000000000.000000
;THIRDAIM_perspectivemult  dd       400.000000             ;256

THIRDAIM_aimdotsizemult_camera	  dd	   THIRDP_DOT_DISTANCE_MULTIPLIER  ;multiplier for gun dot size between previously-sized dot and camera

THIRDP_aimdot_lastx	  dd	   0
THIRDP_aimdot_lasty	  dd	   0
THIRDP_aimdot_lastz	  dd	   0
THIRDP_aimdot_lastobj	  dd	   0	   ;if NULL, not aimdot

THIRDP_aimdot_sourcex	  dd	   0
THIRDP_aimdot_sourcey	  dd	   0
THIRDP_aimdot_sourcez	  dd	   0

;========================================================
;MATRIX EFFECT DATA
;========================================================

BIONICWOMAN_enabled		db	0
DisplayGSPD_BOOL		db	0
GameSpeedDisplayString		db	"Game Speed: %.5f",0

align 4
AT100SimulatedObject:
				dd	0
				dd	0
DefaultSlowSpeed		dd	0
DefaultInterval 		dd	0
				dd	0
				dd	0
				dd	0
DefaultEnterTransitionInterval	dd	0
DefaultExitTransitionInterval	dd	0

NormalGameSpeed     dd	    0	 ;updated with variable from executable or INI and/or ActionType 100-101
OverrideSVGSpeed    dd	    FALSE
OrigNormalGameSpeed dd	    0

UseMXTBITE		    dd	    0
MXTStateEnabled 	    db	    0
MXTStateInterval	    dd	    0
MXTEnterTransitionInterval  dd	    0
MXTExitTransitionInterval   dd	    0
MXTLastTick		    dd	    0
MXTSlowSpeedCurrent	    dd	    0
MXTSpeedVariationCurrent    dd	    0	   ;[NormalGameSpeed]-[MXTSlowSpeedCurrent]

;========================================================
;QUICKSAVE FUNCTION
;========================================================

QUICKSAVE_enabled	    dd	    0

FindNextSaveGame_BUF	    db	    512 dup 0
FindNextSaveGame_COUNT_STR  db	    "%.3u",0

QUICKSAVE_tick		    dd	    0
QUICKSAVE_savedone_BOOL     db	    0
QUICKSAVE_levelsave_STR     db	    "LEVEL SAVED",0
	  QUICKSAVE_levelsave_STR_END:

QUICKSAVE_levelsave_err_STR	db	"ERROR SAVING LEVEL",0
	  QUICKSAVE_levelsave_err_STR_END:

QUICKSAVE_filedisplayname_STR	db	"ATX Quick Save",0
	  QUICKSAVE_filedisplayname_STR_END:

QUICKSAVE_currentfilename   db	    50 dup 0	 ;section_gamesaving,key_qscurrentfile

QUICKSAVE_finddatabuf	    FINDDATA

;========================================================
;LINST CHEAT DATA
;========================================================

LINST_enabled		db	0
LINST_CurrentNode	dd	0
LINST_RootNode		dd	0
LINST_InstanceCount	dd	0
LINST_cycleleftkey	dd	0
LINST_cyclerightkey	dd	0
LINST_cyclepreviouskey	dd	0

LINST_instcount_STR	db	"Current Instance Display (of %u):",0
LINST_instID_STR	db	"Instance ID (name): 0x%.8X",0
LINST_instaddr_STR	db	"Instance address: 0x%.8X",0
LINST_instvtable_STR	db	"VTable address: 0x%.8X",0
LINST_insttype_STR	db	"Class/VTable type: %s",0

LINST_nodetype_STR	db	"Current tree node info: %s, %s, %s",0
LINST_nt_root_STR	db	"root node",0
LINST_nt_std_STR	db	"standard node",0
LINST_nt_left_STR	db	"has left node",0
LINST_nt_noleft_STR	db	"no left node",0
LINST_nt_right_STR	db	"has right node",0
LINST_nt_noright_STR	db	"no right node",0

;========================================================
;ANIMAL PROJECTILE DATA
;========================================================

animal_projectile_buffer	dd	0      ;starts with a list of pointers to the objects in the rest of buffer
animal_projectile_buffer_size	dd	0

SPTSTR_ProjectileName		       db     "ProjectileName%u",0
SPTSTR_MinDistance		       db     "MinDistance",0
SPTSTR_MinDistanceHoriz 	       db     "MinDistanceHoriz",0
SPTSTR_ForwardDistanceFromHead	       db     "ForwardDistanceFromHead",0
SPTSTR_ProjectileSpeed		       db     "ProjectileSpeed",0
SPTSTR_LaunchProbability	       db     "LaunchProbability",0
SPTSTR_MinLaunchInterval	       db     "MinLaunchInterval",0
SPTSTR_AnimalViewAngle		       db     "AnimalViewAngle",0
SPTSTR_UseHorizontalAutoAim	       db     "UseHorizontalAutoAim",0
SPTSTR_UseVerticalAutoAim	       db     "UseVerticalAutoAim",0
SPTSTR_ProjectileExtinguishTime        db     "ProjectileExtinguishTime",0
SPTSTR_ProjectileZSpeedAdjust	       db     "ProjectileZSpeedAdjust",0
SPTSTR_ProbabilityInterval	       db     "ProbabilityInterval",0

;========================================================
;FIXED-SPEED AT110 DATA
;========================================================

FIXS_numberofAT110instances	dd	0
FIXS_numberofSPTprojectile	dd	0

FIXS_lasttickglobal		dd	0
FIXS_savedatatempbuffer 	dd	0
FIXS_savedatatempbuffer_size	dd	0
FIXS_mainbuffer_sizediv2	dd	0
FIXS_mainbuffer_halfend 	dd	0
FIXS_mainbuffer 		dd	0	;buffer structure:
						;first half = projectile name IDs in DWORDS
						;second half = series of pointers structures containing data (valid if IDs are non-zero)
						;buffer size =
						;   ([FIXS_numberofAT110instances]+[FIXS_numberofSPTprojectile])*4*2

AT110_EMULATED_OBJECT		dd	8 dup 0

;========================================================
;AT113 AND AT112 DATA
;========================================================

AT113_PLAYER_AITYPE_NON5_SET	 db	 FALSE
AT113_SavegameAITypeUsed_BOOL	 dd	 FALSE
AT113_SavegameAITypeValue	 dd	 0
AT112_InputTogglerID		 dd	 -1	  ;lowest byte = keyboard state, 2nd byte = mouse state
						  ;for keyboard only, 0FFxxh, for mouse only, 0xxFFh
						  ;high WORD = ignored


;========================================================
;CBACKDROP COLLECTOR DATA
;========================================================

CBACKDROP_buffer		 dd	 0
CBACKDROP_instancecount 	 dd	 0
CBACKDROP_buffercapacity	 dd	 0


;========================================================
;TEMPORARY
;========================================================

temptestbool	db	0
temptestbool_2	db	0
temptestbool_3	db	0
temptestfilehandle	dd	0
temptestfilename	db	"C:\TEMPTEST.TXT",0

temptestprintstr	db	"0x%.8X : by %s, %s",0Dh,0Ah,0

temptesttempbuf 	db	600 dup 0

tttempvar	dd	0
tttempvar2	dd	0


ttaddr1        dd 601932h		       ;5CD02Eh - K6
ttptr1	       dd TESTENTER_A
ttcode1:   ;9
       call DWORD [ttptr1]
       nop
       nop
       nop
       nop


ttaddr2        dd 5F21D2h		       ;5BDEA0h  - K6
ttptr2	       dd TESTCURRENT_A
ttcode2: ;8
      call DWORD [ttptr2]
      nop
      nop

ttaddr3        dd 601949h		       ;5CD045h - K6
ttptr3	       dd TESTEXIT_A
ttcode3:   ;6
      jmp DWORD [ttptr3]

;========================================================
;CLASS OUTPUTTER (ALPHA) DATA
;========================================================

EnableClassOutputter	dd	0      ;if FALSE, then all other values are null/false as well
COutP_ACTIVE		db	0
COutP_MainBuffer	dd	0      ;Divided into three parts: first = mem addresses, second = mem sizes, all DWORDs
				       ;size = (COutP_MaxInstanceCount*4)*2

COutP_CurrInstanceCount dd	0

COutP_MaxInstanceCount	dd	1000000
COutP_Count_STR 	db	"COUTP last instance count: %u",0

COutP_OutputFileName	db	"c:\tresclasses.inc",0
COutP_lpCObject_STR	db	"lpCObject"
	 COutP_lpCObject_STR_END:
			db	0


COutP_FileHandle	dd	0

COutP_FileTemplateHeader:
db ";=================================================================",0Dh,0Ah
db ";TRESPASSER CLASSES",0Dh,0Ah
db ";=================================================================",0Dh,0Ah
COutP_FileTemplateHeader_END:

COutP_FileTemplateClassStruct:
db 0Dh,0Ah
db "customstruc %s",0Dh,0Ah
db "   ;inherits: %s",0Dh,0Ah
db "                  .lpVTable               dd ?",0Dh,0Ah
db 0

COutP_FileTemplateClassMember:
db "     member %.4Xh,.%s%.4Xh,%-40s dd ?",0Dh,0Ah
db 0

COutP_FileTemplateClassEnds:
db "     strucsize %.4Xh",0Dh,0Ah
db "endcs",0Dh,0Ah
db 0

CDD_filename		db	"tresclasses.cdd",0

;========================================================
;DirectDraw ENUM OUTPUT DATA
;========================================================

UseOutputDDrawEnum		dd	0
OutputDDrawEnum_LastEnum	db	0


DDRAWENUMOUT_Header_STR db	0Dh,0Ah
			db	"DirectDraw-enumerated resolutions list (raw):",0Dh,0Ah
DDRAWENUMOUT_Header_STR_END	db	0

DDRAWENUMOUT_Res_STR	db	"%ux%u, %u bit, %uHz",0Dh,0Ah
			db	0

ForcedResolutionsList_STR	db	201 dup 0
ForcedResolutionsScan_STR	db	"%ux%u",0

ForcedResolutionsBuffer:
		dd	20 dup 0	 ;series of Width and Height value (10 max)
ForcedResolutionsBuffer_END:

UseShowRefreshRates	dd	0

;========================================================
;AT114 DATA
;========================================================
;note: error message exchange the terms sub-group and location group
;to comply with documentation

AT114_Error_Main		db	0Dh,0Ah,"ActionType 114 instance initialization attempt:",0Dh,0Ah
AT114_Error_Main_end		db	0
AT114Error_Success		db	"Successful instance initialization.",0Dh,0Ah
				db	"Address: 0x%.8X; Size: %u bytes; Number of location groups: %u",0Dh,0Ah
				db	"Number of instances: %u; Total probability value: %u",0Dh,0Ah
				db	0
AT114Error_NoMAINGROUP		db	"Failed. No A00 MAIN GROUP found.",0Dh,0Ah,0
AT114Error_InvalidFrameValue	db	"Failed. Invalid Frame (number of groups) value (%u).",0Dh,0Ah,0
AT114Error_InvalidSampleValue	db	"Failed. Invalid Sample (number of instances) value (%u).",0Dh,0Ah,0
AT114Error_NoLocalMem		db	"Failed. Unable to allocate memory.",0Dh,0Ah
				db	"Size = %u bytes; Type = %s; Total allocations count = %u",0Dh,0Ah
				db	"Total requested allocations size = %u bytes",0Dh,0Ah
				db	0
     AT114Error_NoLocalMem_maintemp  db      "main temp buffer",0
     AT114Error_NoLocalMem_smalltemp db      "temp location buffer",0
     AT114Error_NoLocalMem_mainobj   db      "main AT114 instance",0
AT114Error_MissingInstance	db	"Failed. Missing or invalid A%0.2d string in A00 MAIN GROUP for instance teleport.",0
AT114Error_InvalidProb		db	"Failed. Total probability LoopCount values for all groups is zero.",0
AT114Error_InvalidXYZ		db	"Failed. Invalid or missing %s float values.",0Dh,0Ah
				db	"sub-group A%0.2d, location group A%0.2d",0Dh,0Ah
				db	0
     AT114Error_InvalidXYZ_xyz	     db      "X, Y, and/or Z position",0
     AT114Error_InvalidXYZ_xyzfree   db      "XFree, YFree, and/or ZFree orientation",0

AT114Error_RT_Main		db	0Dh,0Ah,"ActionType 114 Run-Time Error:",0Dh,0Ah
AT114Error_RT_Main_end		db	0
AT114Error_RT_InvalidDestObj	db	"TeleportDestObjectName entry has invalid instance in",0Dh,0Ah
				db	"sub-group A%0.2d, location group A%0.2d.",0Dh,0Ah,0


;========================================================
;TPAs
;========================================================

AlternateAmbientTPA_FN		   db	   MAX_PATH dup 0
AlternateEffectsTPA_FN		   db	   MAX_PATH dup 0
AlternateMenuTPA_FN		   db	   MAX_PATH dup 0
AlternateStreamTPA_FN		   db	   MAX_PATH dup 0

align 4
LVLAltTPAsDisable		   dd	   0
LVLAltAmbientTPADescStruct	   dd	   0
LVLAltEffectsTPADescStruct	   dd	   0
LVLAltStreamTPADescStruct	   dd	   0
LVLAltTempVar			   dd	   0

LVLAltINIAmbientKeyName 	   db	   "Ambient",0
LVLAltINIEffectsKeyName 	   db	   "Effects",0
LVLAltINIStreamKeyName		   db	   "Stream",0
LVLAltINIAddTPAFNSectionName	   db	   "AdditiveTPAFilenames",0


;========================================================
;HUD data
;========================================================

UseHUD				dd	0
HUDon				dd	1

HUD_ImagesPointers:
	HUD_PlayerHealthBG	HUDImgInfo
	HUD_PrimaryAmmoBG	HUDImgInfo
	HUD_SecondaryAmmoBG	HUDImgInfo
	HUD_Digits		HUDDigitsInfo
HUD_ImagesPointers_END:

HUD_ImagesININamesPointers:
	HUD_PlayerHealthBG_INI	dd	    HUD_INIEntryNameA
	HUD_PrimaryAmmoBG_INI	dd	    HUD_INIEntryNameB
	HUD_SecondaryAmmoBG_INI dd	    HUD_INIEntryNameC
	HUD_Digits_INI		HUDDigits   HUD_INIEntryNameD,HUD_INIEntryNameE,HUD_INIEntryNameF,\
					    HUD_INIEntryNameG,HUD_INIEntryNameH,HUD_INIEntryNameI,\
					    HUD_INIEntryNameJ,HUD_INIEntryNameK,HUD_INIEntryNameL,\
					    HUD_INIEntryNameM
HUD_ImagesININamesPointers_END:

HUD_ImagesLocationININame	db	"ImagesLocations.ini",0
HUD_INISectName_Locations	db	"ImageFilenames",0
HUD_INISectName_Health		db	"PlayerHealthCountBG",0
HUD_INISectName_Ammo1		db	"PrimaryAmmoCountBG",0
HUD_INISectName_Ammo2		db	"SecondaryAmmoCountBG",0

HUD_PlayerHealthBG_Info 	HUDBGInfo
HUD_PrimaryAmmoBG_Info		HUDBGInfo
HUD_SecondaryAmmoBG_Info	HUDBGInfo

HUD_INIEntryNamenone	db	"none",0
HUD_INIEntryNameA	db	"PlayerHealthCountBG",0
HUD_INIEntryNameB	db	"PrimaryAmmoCountBG",0
HUD_INIEntryNameC	db	"SecondaryAmmoCountBG",0
HUD_INIEntryNameD	db	"Digit0Image",0
HUD_INIEntryNameE	db	"Digit1Image",0
HUD_INIEntryNameF	db	"Digit2Image",0
HUD_INIEntryNameG	db	"Digit3Image",0
HUD_INIEntryNameH	db	"Digit4Image",0
HUD_INIEntryNameI	db	"Digit5Image",0
HUD_INIEntryNameJ	db	"Digit6Image",0
HUD_INIEntryNameK	db	"Digit7Image",0
HUD_INIEntryNameL	db	"Digit8Image",0
HUD_INIEntryNameM	db	"Digit9Image",0

HUD_INIEntryBGInfoTable HUDBGInfo HUD_INIEntryAlignX,HUD_INIEntryAlignY,\
				  HUD_INIEntryDispX,HUD_INIEntryDispY,\
				  HUD_INIEntryDigitsX,HUD_INIEntryDigitsY,\
				  HUD_INIEntryDigits2X,HUD_INIEntryDigits2Y,\
				  HUD_INIEntryDigitPad,HUD_INIEntryUseResize,\
				  HUD_INIEntryResizeX,HUD_INIEntryResizeY,\
				  HUD_INIEntryUseDigits2
HUD_INIEntryBGInfoTable_END:

HUD_INIEntryAlignX	db	"AlignmentX",0
HUD_INIEntryAlignY	db	"AlignmentY",0
HUD_INIEntryDispX	db	"DisplacementX",0
HUD_INIEntryDispY	db	"DisplacementY",0
HUD_INIEntryDigitsX	db	"DigitsOffsetX",0
HUD_INIEntryDigitsY	db	"DigitsOffsetY",0
HUD_INIEntryDigits2X	db	"Digits2OffsetX",0
HUD_INIEntryDigits2Y	db	"Digits2OffsetY",0
HUD_INIEntryDigitPad	db	"UseDigitPadding",0
HUD_INIEntryUseResize	db	"UseResizing",0
HUD_INIEntryResizeX	db	"DefaultResizeXRes",0
HUD_INIEntryResizeY	db	"DefaultResizeYRes",0
HUD_INIEntryUseDigits2	db	"UseDisplayMaxValue",0

HUD_ConvertPixelData_RunOnce	db	0

align 4
HUD_ddbacksurfacepixeldesc   DDPIXELFORMAT
HUD_ddbacksurfacergbtype     dd 	0

;========================================================
;Temporary DirectX data
;========================================================

align 4
bltclientsurface	DDSURFACEDESC
			dd	4 dup 0

bltclientsurfaceretinfo DDSURFACEDESC
			dd	4 dup 0

bltclientsurfacehandle	dd	0
bltclientsourcearea	RECT
bltclientdestarea	RECT
bltcientbltfx		DDBLTFX

;========================================================
;Path Tracing Data
;========================================================
align 4

PT_enabled		dd	0
PT_runonce		dd	0
PT_lasttick		dd	0
PT_displayed		dd	0
PT_color		dd	0

PT_maxpos		dd	0
PT_interval		dd	0
PT_msecsdisplayperpos	dd	0	;must be non-null
PT_fadedelay		dd	0
PT_radius		dd	0
PT_radiusexp2		dd	0

PT_positions		STDQUEUEINFO

;========================================================
;UseObj cheat Data
;========================================================

UseObjErr1_STR		db	"Cannot use object: no OBJ cheat enabled",0
UseObjErr2_STR		db	"Cannot use object: no object selected",0

UseObjTempInst		CAT115







