;========================================================
;ATXconfig.ini INI file data
;========================================================

;section names
section_general 	    db	    "General",0
section_vars		    db	    "Variables",0
section_mxt		    db	    "MatrixTres",0
section_hotkeys 	    db	    "Hotkeys",0
section_fly		    db	    "FlyCheat",0
section_ai		    db	    "AISettings",0
section_troubleshooting     db	    "Troubleshooting",0
section_actjumpnew	    db	    "ActJumpNewSettings",0
section_videorecording	    db	    "VideoRecording",0
section_followdinocheat     db	    "FollowDinoCheat",0
section_thirdpersoncheat    db	    "ThirdPersonCheat",0
section_nightmode	    db	    "NightMode",0
section_gamesaving	    db	    "GameSaving",0
section_fogsettings	    db	    "FogSettings",0
section_tpafiles	    db	    "TPAFiles",0
section_pathtracing	    db	    "PathTracing",0

;key names
key_sdbg	    db	    "EnableTimedTresStrDbg",0
key_wndo	    db	    "EnableWindowedMode",0
key_dems	    db	    "DisableDemoExitScreen",0
key_dswp	    db	    "DisableSwapFileDeletion",0
key_rand	    db	    "EnableInstanceRandomizer",0
key_highres	    db	    "EnableHighResolutions",0
key_gamediff	    db	    "GameDifficulty",0
key_usenewitems     db	    "EnableNewMenuItems",0
key_dinovocal	    db	    "NewDinoSoundTypesCount",0
key_maxdinos	    db	    "MaxActiveDinos",0
key_lbg 	    db	    "EnableNewLevelLoadBGs",0
key_disablefastload db	    "DisableFastRestart",0
key_atx3dnow	    db	    "EnableATX3DNowOptimizations",0
;key_atxsse          db      "EnableSSEOptimizations",0
key_oldvprotect     db	    "UseOldVirtualProtect",0
;key_showrates       db      "ShowVideoModeRefreshRates",0
key_usehud	    db	    "UseHUD",0

key_draw	    db	    "ObjectClarityDrawDistance",0
key_grav	    db	    "Gravity",0
key_gspd	    db	    "NormalGameSpeed",0
key_gpsdnosvgset    db	    "OverrideSaveGameSpeed",0
key_camfov	    db	    "CameraFOVDegrees",0

key_flyd	    db	    "InputAutoRepeatDelay",0
key_flys	    db	    "PlayerMovementSpeed",0

key_mxtb	    db	    "EnableMXTOnActBite",0
key_intr	    db	    "MinMXTSlowdownDuration",0
key_slow	    db	    "BIONICWOMANMXTSlowdownSpeed",0
key_mxtr	    db	    "ActBitePlayerDinoRadius",0
key_mxtenterintr    db	    "MXTEnterTransitionInterval",0
key_mxtexitintr     db	    "MXTExitTransitionInterval",0

key_ktog	    db	    "ToggleNewKeys",0
key_kmap	    db	    "Toggle2DMapDisplay",0
key_kdom	    db	    "ToggleDinosOnMap",0
key_kdrs	    db	    "DecreaseDrawDistance",0
key_kdra	    db	    "IncreaseDrawDistance",0
key_kcan	    db	    "ToggleCANIMALInfoDisplay",0
key_kmse	    db	    "ToggleSelectedDinoOnMap",0
key_kcal	    db	    "CycleCANIMALInfoLeft",0
key_kcar	    db	    "CycleCANIMALInfoRight",0
key_drvq	    db	    "ExitATXDRVMode",0
key_linstleft	    db	    "LINSTCycleLeft",0
key_linstright	    db	    "LINSTCycleRight",0
key_linstprevious   db	    "LINSTCyclePrevious",0

key_ainb	    db	    "AllowDinosInBuildings",0
key_stnr	    db	    "ForceNoStayNearTarget",0
key_staw	    db	    "ForceNoStayAwayTarget",0
key_dpts	    db	    "AddHitPointsToAllDinos",0
key_frez	    db	    "AddFreezeDistanceToAllDinos",0

key_noa3d	    db	    "DisableA3DdllDetection",0
key_outddrawenum    db	    "OutputDirectDrawVidModeEnum",0
key_forcedmodes     db	    "ForcedVideoModesList",0
key_highresmax	    db	    "OverrideMaxResolutionX",0
key_classoutput     db	    "UseClassOutputter",0

key_nojump	    db	    "DisableActJumpNew",0
key_noquadjump	    db	    "DisableJumpingQuadrupeds",0
key_pushdef	    db	    "DefaultPush",0
key_jumpadef	    db	    "DefaultJumpAngle",0
key_jumptdef	    db	    "DefaultJumpTendancy",0
key_reppdef	    db	    "DefaultRepeatPeriod",0
key_tcperioddef     db	    "DefaultTendancyCheckPeriod",0
key_anglebody	    db	    "DefaultMaxBodyTargetDirAngle",0
key_anglehead	    db	    "DefaultMaxHeadTargetDirAngle",0
key_minspeed	    db	    "DefaultMinTotalVelocity",0
key_mindirspeed     db	    "DefaultMinDirectionalVelocity",0
key_maxdirangle     db	    "DefaultMaxDirVelocityAngle",0
key_mintargetdist   db	    "DefaultMinTargetDistance",0
key_maxtargetdist   db	    "DefaultMaxTargetDistance",0

key_width	    db	    "Width",0
key_height	    db	    "Height",0
key_framerate	    db	    "Framerate",0
key_maxframes	    db	    "MaxFrameCount",0
key_savemethod	    db	    "SaveMethod",0
key_nolowfpscomp    db	    "NoLowFPSCompensation",0
key_enableaudio     db	    "MCIAudioCapture",0
key_bitspersample   db	    "MCIBitsPerSample",0
key_channelcount    db	    "MCIChannelCount",0
key_samplespersec   db	    "MCISamplesPerSec",0
key_bytespersec     db	    "MCIBytesPerSec",0
key_usewritethrough db	    "UseWriteThroughToDisk",0

key_mousesens	    db	    "MouseSensitivity",0
key_inputrate	    db	    "MaxKeyInputRate",0
key_defaultdist     db	    "DefaultDistanceFromDino",0
key_distancespeed   db	    "DistanceChangeSpeed",0
key_invertmousemul  db	    "VerticalMouseMvtMultiplier",0

key_tpinputrate     db	    "MaxKeyInputRate",0
key_tpkeyforward    db	    "ZoomInKey",0
key_tpkeyback	    db	    "ZoomOutKey",0
key_tpkeyreset	    db	    "ZoomResetKey",0
key_tpkeyup	    db	    "CameraUpKey",0
key_tpkeydown	    db	    "CameraDownKey",0
key_tpkeyaim	    db	    "AimGunKey",0
key_tptoggleaim     db	    "AimGunToggleKey",0
key_tptoggleaimdot  db	    "AIMdotToggleKey",0
key_tpdistance	    db	    "DefaultZoomDistance",0
key_tpdistancespeed db	    "ZoomChangeSpeed",0
key_tpcamspeed	    db	    "CameraRotateSpeed",0
key_tpcamzdisp	    db	    "CameraHeightDisplacement",0
key_tpcamzangledef  db	    "CameraAngleDefault",0

key_nightenable     db	    "EnableNightMode",0
key_nightfognear    db	    "FogNearValue",0
key_nightfogfar     db	    "FogFarValue",0
key_nightfogcolor   db	    "FogColor",0
key_nightcpmax	    db	    "CParticlesColorMax",0
key_nightcpdef	    db	    "CParticlesTypes",0
key_nightclutstart  db	    "DefaultGlobalClutStart",0
key_nightclutstop   db	    "DefaultGlobalClutStop",0
key_ambientlight    db	    "FixedAmbientLight",0
key_nightskyheight  db	    "SkyHeight",0
key_nightfogpower   db	    "FogPower",0
key_nightfoghalf    db	    "FogHalf",0

key_qscurrentfile   db	    "QuickSaveCurrentFileName",0
key_enableatxqs     db	    "EnableATXQuickSave",0

key_deffogcolor     db	    "DefaultGameFogColor",0
key_overfogvalues   db	    "OverrideGameFogValues",0
key_fogpowerforced  db	    "FogPowerForcedValue",0
key_foghalfforced   db	    "FogHalfForcedValue",0

key_tpaambient	    db	    "AlternateAmbientTPA",0
key_tpaeffects	    db	    "AlternateEffectsTPA",0
key_tpamenu	    db	    "AlternateMenuTPA",0
key_tpastream	    db	    "AlternateStreamTPA",0
key_tplvldisable    db	    "DisableAlternateLevelTPAs",0

key_ptpathtraceon   db	    "EnablePathTracing",0
key_ptrate	    db	    "UpdateInterval",0
key_ptmaxpos	    db	    "MaxPositions",0
key_ptsecsperpos    db	    "DisplayTimePerPosition",0
key_ptfadedelay     db	    "FadeDelay",0
key_ptradius	    db	    "MinPositionRadius",0
key_ptcolor	    db	    "CursorColor",0

;========================================================
;default values
;========================================================
gen_deffogcolor 	db	"0x00D7E6FF",0

;FLY cheat defaults
fly_speed_str		db	"0.07",0
fly_delay_int		equ	10

;MatrixTres on Actbite defaults
DefaultMXTRadius		db	"15.0",0
DefaultSlowSpeed_CONST		db	"0.4",0
DefaultInterval_CONST		equ	2400
DefaultEnterInterval_CONST	equ	1200
DefaultExitInterval_CONST	equ	1200

;ActJumpNew defaults
INI_Push_Def		db	"65.0",0
INI_JumpAngle_Def	db	"65.0",0
INI_JumpTDef		equ	75
INI_RepeatPDef		equ	8000
INI_TCPeriodDef 	equ	6000

INI_MaxBodyTargetDirAngle_def	  db	"0",0
INI_MaxHeadTargetDirAngle_def	  db	"0",0
INI_MinTotalVelocity_def	  db	"0",0
INI_MinDirectionalVelocity_def	  db	"0",0
INI_MaxDirVelocityAngle_def	  db	"0",0
INI_MinTargetDistance_def	  db	"0",0
INI_MaxTargetDistance_def	  db	"0",0

;FOLLOWDINO defaults
followdino_mousesens	   db	   "0.005",0
followdino_inputrate	   db	   "60.0",0
followdino_cammvtrate	   db	   "60.0",0
followdino_defaultdist	   db	   "6.0",0
followdino_distancespeed   db	   "0.01",0
followdino_invertmousemul  db	   "1.0",0

;THIRDP defaults
tp_tpinputrate	   db	   "60.0",0
tp_tpcamrate	   db	   "60.0",0
tp_tpdistance	   db	   "2.0",0
tp_tpdistancespeed db	   "0.01",0
tp_tpcamspeed	   db	   "0.06",0
tp_tpcamzdisp	   db	   "1.0",0
tp_tpcamzangledef  db	   "-20.0",0

;NIGHTMODE defaults
def_nightenable    equ	   FALSE
def_nightfognear   db	   "-2.0",0
def_nightfogfar    db	   "-1.0",0
def_nightfogcolor  db	   "0x00080818",0
def_nightcpmax	   db	   "0x002D2D2D",0
def_nightcpdef	   equ	   (CParticlesAll-CParticlesMetalHard1)
def_nightclutstart db	   "0x000F0F0F",0
def_nightclutstop  db	   "0x00373737",0
def_nightamblight  db	   "0.0",0
def_nightskyheight db	   "100000000.0",0
def_nightfogpower  db	   "-1.0",0
def_nightfoghalf   db	   "-1.0",0

;GAME SAVING defaults
def_qscurrentfile  db	   "none",0

;PATH TRACING defaults
def_ptinterval	       equ     3000
def_ptmaxpos	       equ     40
def_ptmsecsperpos      equ     200000
def_ptfadedelay        equ     180000
def_ptradius	       db      "10.000000",0
def_ptcolor	       db      "0x0000FF00",0

;========================================================
  ;dd   procedure,section,key,default value or pointer to,destination

INI_ENTRIES_TABLE:
   dd	INI_INT_PROC,section_general,key_sdbg,0,UseTRESSTRDBG
   dd	INI_INT_PROC,section_general,key_wndo,0,UseWINDOWED
   dd	INI_INT_PROC,section_general,key_dems,1,UseDEMOHACK
   dd	INI_INT_PROC,section_general,key_rand,1,UseRandomInstanceLocations
   dd	INI_INT_PROC,section_general,key_highres,1,UseHighResolutionsHack
   dd	INI_INT_PROC,section_general,key_gamediff,2,GameDifficultyValue
   dd	INI_INT_PROC,section_general,key_usenewitems,1,UseNewMenuItems
   dd	INI_INT_PROC,section_general,key_dinovocal,23,UseNewDinoVocals
   dd	INI_INT_PROC,section_general,key_maxdinos,0,UseMaxActiveDinos
   dd	INI_INT_PROC,section_general,key_lbg,1,UseNewBackgroundImages
   dd	INI_INT_PROC,section_general,key_disablefastload,FALSE,DisableFastLoad
   dd	INI_INT_PROC,section_general,key_atx3dnow,FALSE,UseATX3DNowOpts
;   dd   INI_INT_PROC,section_general,key_atxsse,FALSE,UseATXSSEOpts
   dd	INI_INT_PROC,section_general,key_oldvprotect,FALSE,UseOldVirtualProtectFunction
   dd	INI_INT_PROC,section_general,key_usehud,FALSE,UseHUD
;   dd   INI_INT_PROC,section_general,key_showrates,FALSE,UseShowRefreshRates

   dd	INI_FLOAT_PROC,section_vars,key_draw,ZERO_STRING,UseDRAWDISTANCE
   dd	INI_FLOAT_PROC,section_vars,key_grav,ZERO_STRING,UseGRAVITY
   dd	INI_FLOAT_PROC,section_vars,key_gspd,ZERO_STRING,NormalGameSpeed
   dd	INI_INT_PROC,section_vars,key_gpsdnosvgset,FALSE,OverrideSVGSpeed
   dd	INI_FLOAT_PROC,section_vars,key_camfov,ZERO_STRING,AT06_CameraFOV_Value

   dd	INI_INT_PROC,section_fly,key_flyd,fly_delay_int,UseFlyKeyDelay
   dd	INI_FLOAT_PROC,section_fly,key_flys,fly_speed_str,UseFlySpeed_ORIG

   dd	INI_INT_PROC,section_mxt,key_mxtb,0,UseMXTBITE
   dd	INI_INT_PROC,section_mxt,key_intr,DefaultInterval_CONST,DefaultInterval
   dd	INI_FLOAT_PROC,section_mxt,key_slow,DefaultSlowSpeed_CONST,DefaultSlowSpeed
   dd	INI_FLOAT_PROC,section_mxt,key_mxtr,DefaultMXTRadius,UseMXTRadius
   dd	INI_INT_PROC,section_mxt,key_mxtenterintr,DefaultEnterInterval_CONST,DefaultEnterTransitionInterval
   dd	INI_INT_PROC,section_mxt,key_mxtexitintr,DefaultExitInterval_CONST,DefaultExitTransitionInterval

   dd	INI_KEY_PROC,section_hotkeys,key_ktog,ZERO_STRING,UseToggleNewKeys	    ;(does not include additional cheat-specific and respectively named keys)
   dd	INI_KEY_PROC,section_hotkeys,key_kdrs,ZERO_STRING,UseDrawDistSubKey
   dd	INI_KEY_PROC,section_hotkeys,key_kdra,ZERO_STRING,UseDrawDistAddKey
   dd	INI_KEY_PROC,section_hotkeys,key_drvq,ZERO_STRING,UseATXDRVEscKey
   dd	INI_KEY_PROC,section_hotkeys,key_linstleft,ZERO_STRING,LINST_cycleleftkey
   dd	INI_KEY_PROC,section_hotkeys,key_linstright,ZERO_STRING,LINST_cyclerightkey
   dd	INI_KEY_PROC,section_hotkeys,key_linstprevious,ZERO_STRING,LINST_cyclepreviouskey

   dd	INI_INT_PROC,section_ai,key_ainb,0,UseNoGetOut
   dd	INI_INT_PROC,section_ai,key_stnr,0,UseNoStayNear
   dd	INI_INT_PROC,section_ai,key_staw,0,UseNoStayAway
   dd	INI_FLOAT_PROC,section_ai,key_dpts,ZERO_STRING,UseCAnimalHitPoints
   dd	INI_FLOAT_PROC,section_ai,key_frez,ZERO_STRING,UseSleepWake

   dd	INI_INT_PROC,section_troubleshooting,key_noa3d,0,UseDisableA3Ddll
   dd	INI_INT_PROC,section_troubleshooting,key_outddrawenum,0,UseOutputDDrawEnum
   dd	INI_STR_EXT_PROC,section_troubleshooting,key_forcedmodes,ZERO_STRING,ForcedResolutionsList_STR
   dd	INI_INT_PROC,section_troubleshooting,key_highresmax,2048,HIGHRESCMPREPLACE
   dd	INI_INT_PROC,section_troubleshooting,key_classoutput,FALSE,EnableClassOutputter
   dd	INI_INT_PROC,section_troubleshooting,key_dswp,0,UseDisableSWPDelete

   dd	INI_INT_PROC,section_actjumpnew,key_nojump,FALSE,UseDisableActJumpNew
   dd	INI_INT_PROC,section_actjumpnew,key_noquadjump,FALSE,UseDisableQuadrupedJumps
   dd	INI_STR_PROC,section_actjumpnew,key_pushdef,INI_Push_Def,Push_INIdef
   dd	INI_STR_PROC,section_actjumpnew,key_jumpadef,INI_JumpAngle_Def,JumpAngle_INIdef
   dd	INI_INT_PROC,section_actjumpnew,key_jumptdef,INI_JumpTDef,JumpTendancy_INIdef
   dd	INI_INT_PROC,section_actjumpnew,key_reppdef,INI_RepeatPDef,RepeatPeriod_INIdef
   dd	INI_INT_PROC,section_actjumpnew,key_tcperioddef,INI_TCPeriodDef,TendancyCheckPeriod_INIdef
   dd	INI_STR_PROC,section_actjumpnew,key_anglebody	 ,INI_MaxBodyTargetDirAngle_def   ,MaxBodyTargetDirAngle_INIdef
   dd	INI_STR_PROC,section_actjumpnew,key_anglehead	 ,INI_MaxHeadTargetDirAngle_def   ,MaxHeadTargetDirAngle_INIdef
   dd	INI_STR_PROC,section_actjumpnew,key_minspeed	 ,INI_MinTotalVelocity_def	  ,MinTotalVelocity_INIdef
   dd	INI_STR_PROC,section_actjumpnew,key_mindirspeed  ,INI_MinDirectionalVelocity_def  ,MinDirectionalVelocity_INIdef
   dd	INI_STR_PROC,section_actjumpnew,key_maxdirangle  ,INI_MaxDirVelocityAngle_def	  ,MaxDirVelocityAngle_INIdef
   dd	INI_STR_PROC,section_actjumpnew,key_mintargetdist,INI_MinTargetDistance_def	  ,MinTargetDistance_INIdef
   dd	INI_STR_PROC,section_actjumpnew,key_maxtargetdist,INI_MaxTargetDistance_def	  ,MaxTargetDistance_INIdef

   dd	INI_INT_PROC,section_videorecording,key_width,320,dibfileheader.BitmapData.biWidth
   dd	INI_INT_PROC,section_videorecording,key_height,240,dibfileheader.BitmapData.biHeight
   dd	INI_INT_PROC,section_videorecording,key_framerate,20,dibfileheader.Framerate
   dd	INI_INT_PROC,section_videorecording,key_maxframes,2500,dibfileheader.MaxFrameCount
   dd	INI_INT_PROC,section_videorecording,key_savemethod,SAVE_METHOD_NEW_DX,NewSaveMethod
   dd	INI_INT_PROC,section_videorecording,key_nolowfpscomp,FALSE,NoLowFPSComp
   dd	INI_INT_PROC,section_videorecording,key_enableaudio,0,mci_audio_capt_enabled
   dd	INI_INT_PROC,section_videorecording,key_bitspersample,16,mci_bitspersample
   dd	INI_INT_PROC,section_videorecording,key_channelcount,2,mci_channelcount
   dd	INI_INT_PROC,section_videorecording,key_samplespersec,22050,mci_samplespersec
   dd	INI_INT_PROC,section_videorecording,key_bytespersec,88200,mci_bytespersec
   dd	INI_INT_PROC,section_videorecording,key_usewritethrough,FALSE,UseRECWriteThrough

   dd	INI_FLOAT_PROC,section_followdinocheat,key_mousesens,followdino_mousesens,FD_mousectrlmultiplier
   dd	INI_FLOAT_PROC,section_followdinocheat,key_inputrate,followdino_inputrate,FD_inputinterval	  ;will be converted to INT
   dd	INI_FLOAT_PROC,section_followdinocheat,key_defaultdist,followdino_defaultdist,FD_distance
   dd	INI_FLOAT_PROC,section_followdinocheat,key_distancespeed,followdino_distancespeed,FD_distancespeed
   dd	INI_FLOAT_PROC,section_followdinocheat,key_invertmousemul,followdino_invertmousemul,FD_invertmousemul

   dd	INI_FLOAT_PROC,section_thirdpersoncheat,key_tpinputrate,tp_tpinputrate,THIRDP_inputrate
   dd	INI_KEY_PROC,section_thirdpersoncheat,key_tpkeyforward,ZERO_STRING,THIRDP_keyforward
   dd	INI_KEY_PROC,section_thirdpersoncheat,key_tpkeyback,ZERO_STRING,THIRDP_keyback
   dd	INI_KEY_PROC,section_thirdpersoncheat,key_tpkeyreset,ZERO_STRING,THIRDP_keyreset
   dd	INI_KEY_PROC,section_thirdpersoncheat,key_tpkeyup,ZERO_STRING,THIRDP_keyup
   dd	INI_KEY_PROC,section_thirdpersoncheat,key_tpkeydown,ZERO_STRING,THIRDP_keydown
   dd	INI_KEY_PROC,section_thirdpersoncheat,key_tpkeyaim,ZERO_STRING,THIRDP_keyaim
   dd	INI_KEY_PROC,section_thirdpersoncheat,key_tptoggleaim,ZERO_STRING,THIRDP_keyaimtoggle
   dd	INI_KEY_PROC,section_thirdpersoncheat,key_tptoggleaimdot,ZERO_STRING,THIRDP_keyaimdottoggle
   dd	INI_FLOAT_PROC,section_thirdpersoncheat,key_tpdistance,tp_tpdistance,THIRDP_distance
   dd	INI_FLOAT_PROC,section_thirdpersoncheat,key_tpdistancespeed,tp_tpdistancespeed,THIRDP_distancespeed
   dd	INI_FLOAT_PROC,section_thirdpersoncheat,key_tpcamspeed,tp_tpcamspeed,THIRDP_camspeed
   dd	INI_FLOAT_PROC,section_thirdpersoncheat,key_tpcamzdisp,tp_tpcamzdisp,THIRDP_camdispz
   dd	INI_FLOAT_PROC,section_thirdpersoncheat,key_tpcamzangledef,tp_tpcamzangledef,THIRDP_camanglez

   dd	INI_INT_PROC,section_nightmode,key_nightenable,def_nightenable,NIGHT_enabled
   dd	INI_FLOAT_PROC,section_nightmode,key_nightfognear,def_nightfognear,NIGHT_FogNearCurrent
   dd	INI_FLOAT_PROC,section_nightmode,key_nightfogfar,def_nightfogfar,NIGHT_FogFarCurrent
   dd	INI_HEX_PROC,section_nightmode,key_nightfogcolor,def_nightfogcolor,NIGHT_FogColorCurrent
   dd	INI_HEX_PROC,section_nightmode,key_nightcpmax,def_nightcpmax,NIGHT_CParticlesColorMax
   dd	INI_INT_PROC,section_nightmode,key_nightcpdef,def_nightcpdef,NIGHT_CParticlesTypes
   dd	INI_HEX_PROC,section_nightmode,key_nightclutstart,def_nightclutstart,NIGHT_DefaultGlobalClutStart
   dd	INI_HEX_PROC,section_nightmode,key_nightclutstop,def_nightclutstop,NIGHT_DefaultGlobalClutStop
   dd	INI_FLOAT_PROC,section_nightmode,key_ambientlight,def_nightamblight,NIGHT_AmbientLight
   dd	INI_FLOAT_PROC,section_nightmode,key_nightskyheight,def_nightskyheight,NIGHT_SkyHeight
   dd	INI_FLOAT_PROC,section_nightmode,key_nightfogpower,def_nightfogpower,NIGHT_FogPower
   dd	INI_FLOAT_PROC,section_nightmode,key_nightfoghalf,def_nightfoghalf,NIGHT_FogHalf

   dd	INI_STR_PROC,section_gamesaving,key_qscurrentfile,def_qscurrentfile,QUICKSAVE_currentfilename
   dd	INI_INT_PROC,section_gamesaving,key_enableatxqs,TRUE,QUICKSAVE_enabled

   dd	INI_HEX_PROC,section_fogsettings,key_deffogcolor,gen_deffogcolor,DEFAULT_FOG_COLOR_VALUE
   dd	INI_INT_PROC,section_fogsettings,key_overfogvalues,FALSE,DISABLE_GAME_FOG
   dd	INI_FLOAT_PROC,section_fogsettings,key_fogpowerforced,ZERO_STRING,FogSettings_ForcedFogPowerValue
   dd	INI_FLOAT_PROC,section_fogsettings,key_foghalfforced,ZERO_STRING,FogSettings_ForcedFogHalfValue

   dd	INI_STR_EXTMAX_PROC,section_tpafiles,key_tpaambient,def_qscurrentfile,AlternateAmbientTPA_FN	 ;the full path is added in MAININIT
   dd	INI_STR_EXTMAX_PROC,section_tpafiles,key_tpaeffects,def_qscurrentfile,AlternateEffectsTPA_FN
   dd	INI_STR_EXTMAX_PROC,section_tpafiles,key_tpamenu,def_qscurrentfile,AlternateMenuTPA_FN
   dd	INI_STR_EXTMAX_PROC,section_tpafiles,key_tpastream,def_qscurrentfile,AlternateStreamTPA_FN
   dd	INI_INT_PROC,section_tpafiles,key_tplvldisable,FALSE,LVLAltTPAsDisable

   dd	INI_INT_PROC,section_pathtracing,key_ptpathtraceon,FALSE,PT_enabled
   dd	INI_INT_PROC,section_pathtracing,key_ptrate,def_ptinterval,PT_interval
   dd	INI_INT_PROC,section_pathtracing,key_ptmaxpos,def_ptmaxpos,PT_maxpos
   dd	INI_INT_PROC,section_pathtracing,key_ptsecsperpos,def_ptmsecsperpos,PT_msecsdisplayperpos
   dd	INI_INT_PROC,section_pathtracing,key_ptfadedelay,def_ptfadedelay,PT_fadedelay
   dd	INI_FLOAT_PROC,section_pathtracing,key_ptradius,def_ptradius,PT_radius
   dd	INI_HEX_PROC,section_pathtracing,key_ptcolor,def_ptcolor,PT_color

INI_ENTRIES_TABLE_END:
;========================================================
